/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.ast;

import java.util.List;

import polyglot.ast.*;
import polyglot.util.Position;

public class SJSessionTry_c extends Try_c implements SJSessionTry
{
	private List<Receiver> sockets; // Move to an extension object?
	private String returned; // For translation (specifically failure handling).

	public SJSessionTry_c(Position pos, Block tryBlock, List<Catch> catchBlocks, Block finallyBlock, List<Receiver> sockets)
	{
		super(pos, tryBlock, catchBlocks, finallyBlock);

		this.sockets = (List<Receiver>) sockets;
	}

	public List<Receiver> sockets()
	{
		return sockets;
	}

	public SJSessionTry sockets(List<Receiver> sockets)
	{
		this.sockets = sockets;

		return this;
	}

	public String getReturned()
	{
		return returned;
	}

	public SJSessionTry setReturned(String returned)
	{
		this.returned = returned;

		return this;
	}
}
