/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.ast.sessops.structuralops;

import java.util.List;

import polyglot.ast.*;
import polyglot.types.Context;
import polyglot.util.Position;

import sj.util.SJLabel;

public class SJInbranchCase_c extends AbstractBlock_c implements SJInbranchCase
{
	private SJLabel lab;

	public SJInbranchCase_c(Position pos, List<Stmt> statements, SJLabel lab)
	{
		super(pos, statements);

		this.lab = lab;
	}

	public Context enterScope(Context c)
	{
		return c; // Push block?
	}

	public SJLabel label()
	{
		return lab;
	}
}
