/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.ast.sessops.structuralops;

import polyglot.ast.*;
import polyglot.util.Position;

public class SJOutwhile_c extends While_c implements SJOutwhile
{
	public SJOutwhile_c(Position pos, Expr cond, Stmt body)
	{
		super(pos, cond, body);
	}

	public SJOutwhile cond(Expr cond)
	{
		return (SJOutwhile) super.cond(cond);
	}

	public SJOutwhile body(Stmt body)
	{
		return (SJOutwhile) super.body(body);
	}

	// Is it actually necessary to override this method?
	protected SJOutwhile_c reconstruct(Expr cond, Stmt body)
	{
		if (cond != this.cond || body != this.body)
		{
			SJOutwhile_c n = (SJOutwhile_c) copy();

			n.cond = cond;
			n.body = body;

			return n;
		}

		return this;
	}
}
