/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.ast.typenodes;

import polyglot.util.Position;

import static sj.SJConstants.SJ_STRING_INWHILE_OPEN;
import static sj.SJConstants.SJ_STRING_INWHILE_CLOSE;

public class SJInwhileNode_c extends SJTypeNode_c implements SJInwhileNode
{
	private SJTypeNode body;

	public SJInwhileNode_c(Position pos, SJTypeNode body)
	{
		super(pos);

		this.body = body;
	}

	public SJTypeNode body()
	{
		return body;
	}

	public SJInwhileNode body(SJTypeNode body)
	{
		this.body = body;

		return this;
	}

	public String nodeToString()
	{
		if (body == null)
		{
			return SJ_STRING_INWHILE_OPEN + SJ_STRING_INWHILE_CLOSE;
		}
		else
		{
			return SJ_STRING_INWHILE_OPEN + body.toString() + SJ_STRING_INWHILE_CLOSE;
		}
	}
}
