/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.ast.typenodes;

import polyglot.util.Position;

import static sj.SJConstants.SJ_STRING_OUTWHILE_OPEN;
import static sj.SJConstants.SJ_STRING_OUTWHILE_CLOSE;

public class SJOutwhileNode_c extends SJTypeNode_c implements SJOutwhileNode
{
	private SJTypeNode body;

	public SJOutwhileNode_c(Position pos, SJTypeNode body)
	{
		super(pos);

		this.body = body;
	}

	public SJTypeNode body()
	{
		return body;
	}

	public SJOutwhileNode body(SJTypeNode body)
	{
		this.body = body;

		return this;
	}

	public String nodeToString()
	{
		if (body == null)
		{
			return SJ_STRING_OUTWHILE_OPEN + SJ_STRING_OUTWHILE_CLOSE;
		}
		else
		{
			return SJ_STRING_OUTWHILE_OPEN + body.toString() + SJ_STRING_OUTWHILE_CLOSE; // Could use treeToString.
		}
	}
}
