/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.ast.typenodes;

import polyglot.ast.TypeNode;
import polyglot.util.Position;

import static sj.SJConstants.SJ_STRING_RECEIVE_OPEN;
import static sj.SJConstants.SJ_STRING_RECEIVE_CLOSE;

public class SJReceiveNode_c extends SJTypeNode_c implements SJReceiveNode
{
	private TypeNode messageTypeNode;

	public SJReceiveNode_c(Position pos, TypeNode messageTypeNode)
	{
		super(pos);

		this.messageTypeNode = messageTypeNode;
	}

	public TypeNode messageTypeNode()
	{
		return messageTypeNode;
	}

	public SJReceiveNode messageTypeNode(TypeNode messageTypeNode)
	{
		this.messageTypeNode = messageTypeNode;
		return this;
	}

	public String nodeToString()
	{
		String message = messageTypeNode().toString(); // toString enough for messageType? or need to manually get full name?

		return SJ_STRING_RECEIVE_OPEN + message + SJ_STRING_RECEIVE_CLOSE;
	}
}
