/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.ast.typenodes;

import polyglot.util.Position;

import sj.SJConstants;
import sj.util.SJLabel;

public class SJRecurseNode_c extends SJTypeNode_c implements SJRecurseNode
{
	private SJLabel lab;

	public SJRecurseNode_c(Position pos, SJLabel lab)
	{
		super(pos);

		this.lab = lab;
	}

	public SJLabel label()
	{
		return lab;
	}

	public String nodeToString()
	{
		return SJConstants.SJ_STRING_RECURSE_PREFIX + label().toString();
	}
}
