/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.ast.typenodes;

import polyglot.util.Position;

import sj.util.SJLabel;

import static sj.SJConstants.SJ_STRING_REC;
import static sj.SJConstants.SJ_STRING_RECURSION_OPEN;
import static sj.SJConstants.SJ_STRING_RECURSION_CLOSE;

public class SJRecursionNode_c extends SJTypeNode_c implements SJRecursionNode
{
	private SJLabel lab;
	private SJTypeNode body;

	public SJRecursionNode_c(Position pos, SJLabel lab, SJTypeNode body)
	{
		super(pos);

		this.lab = lab;
		this.body = body;
	}

	public SJLabel label()
	{
		return lab;
	}

	public SJTypeNode body()
	{
		return body;
	}

	public SJRecursionNode body(SJTypeNode body)
	{
		this.body = body;

		return this;
	}

	public String nodeToString()
	{
		String m = SJ_STRING_REC + " " + label() + " " + SJ_STRING_RECURSION_OPEN;

		if (body == null)
		{
			return m + SJ_STRING_RECURSION_CLOSE;
		}
		else
		{
			return m + body.toString() + SJ_STRING_RECURSION_CLOSE;
		}
	}
}
