/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.ast.typenodes;

import polyglot.ast.TypeNode;
import polyglot.util.Position;

import static sj.SJConstants.SJ_STRING_SEND_OPEN;
import static sj.SJConstants.SJ_STRING_SEND_CLOSE;

public class SJSendNode_c extends SJTypeNode_c implements SJSendNode
{
	private TypeNode messageTypeNode;

	public SJSendNode_c(Position pos, TypeNode messageTypeNode)
	{
		super(pos);

		this.messageTypeNode = messageTypeNode;
	}

	public TypeNode messageTypeNode()
	{
		return messageTypeNode;
	}

	public SJSendNode messageTypeNode(TypeNode messageTypeNode)
	{
		this.messageTypeNode = messageTypeNode; // Unlike polyglot type nodes, no defensive copy.

		return this;
	}

	public String nodeToString()
	{
		String message = messageTypeNode.toString(); // toString enough for messageType? or need to manually get full name?

		return SJ_STRING_SEND_OPEN + message + SJ_STRING_SEND_CLOSE;
	}
}
