/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.ast.typenodes;

import polyglot.ast.TypeNode;

import sj.types.typeobjects.sesstypes.SJType;

/**
 * A SJTypeNode is the internal compiler representation of a parsed session
 * type element.
 */
public interface SJTypeNode extends TypeNode
{
	public SJTypeNode child();
	public SJTypeNode child(SJTypeNode child);

	public SJType type();

	public String nodeToString(); // Could be protected?
	public String treeToString();
}
