/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.del;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.visit.*;

import sj.ast.sessops.structuralops.SJStructuralOperation;
import sj.extension.SJStructuralOperationExt;
import sj.util.SJTypeBuilder;

public class SJStructuralOperationDel_c extends JL_c implements SJStructuralOperationDel
{
	public Node typeCheck(TypeChecker tc) throws SemanticException
	{
		SJStructuralOperation sjso = (SJStructuralOperation) node();
		SJStructuralOperationExt ext = (SJStructuralOperationExt) sjso.ext();

		SJTypeBuilder sjtb = new SJTypeBuilder(tc.job(), tc.typeSystem(), tc.nodeFactory());

		sjso = ext.target((Receiver) sjtb.buildTypes(tc.context(), ext.target())); // Still just a Receiver now, but later a SJSocketVariable.

		return sjso.typeCheck(tc); // Still typecheck node as originally intended.
	}
}
