/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.extension;

import java.util.List;

import polyglot.ast.Ext;

import sj.ast.SJCall;
import sj.ast.sessvars.SJLocalSocket;
import sj.types.typeobjects.typeableinstances.SJMethodInstance;

public interface SJCallExt extends Ext // SJCall doesn't have its own instance object, the AST information is used to find the corresponding SJMethodInstanceObject (as in Poyglot). // Because SJCall has no instance object, we don't record the operation types for the sessions delegated/received.
{
	public List<SJLocalSocket> socketArgs(); // Maybe could make a delegation base class (and instance objects) for session-send and session method-call (and maybe session-returns, although they are monadic).
	//public SJCall socketArgs(List<SJLocalSocket> socketArgs);

	public boolean anonymousReturn(); // Duplicated from SJReturnOperationExt (but currently no instance object for the session-return information - could store in SJMethodInstance, or build an additional SJNamedInstance for it - but return type would still be unknown until after SJTypeChecker pass anyway).
	public String returned(); // Null if not applicable.
	public SJCall returned(String returned);

	public SJMethodInstance sjMethodInstance();
	public SJCall sjMethodInstance(SJMethodInstance sjmi);
}
