/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.extension.proceduredecls;

import java.util.*;

import polyglot.ast.*;

import sj.ast.proceduredecls.SJMethodDecl;
import sj.ast.sessformals.SJFormal;
import sj.ast.typenodes.SJTypeNode;
import sj.types.typeobjects.typeableinstances.SJMethodInstance;

public interface SJMethodDeclExt extends Ext // SJMethodDecl is not SJTypeable. // Should make a SJProcedureDeclExt base class (already have procedure base classes for the AST nodes and instance objects).
{
	public List<SJFormal> sjFormals(); // The SJMethodDecl AST node records all parameters, but here only the session typed parameters are recorded. // The SJFormals recorded here should be aliases to those recorded by the actual AST node. So we just lookup them up each time they're needed (preceding passes e.g. type checking may clone the formals).
	//public SJMethodDecl sjFormals(List<SJFormal> sjFormals);

	public SJTypeNode sjReturnType(); // Null if not a session return type.
	public SJMethodDecl sjReturnType(SJTypeNode returnType);

	public SJMethodInstance sjMethodInstance();
	public SJMethodDecl sjMethodInstance(SJMethodInstance sjmi);
}
