/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.extension.proceduredecls;

import java.util.*;

import polyglot.ast.*;

import sj.ast.proceduredecls.SJMethodDecl;
import sj.ast.sessformals.SJFormal;
import sj.ast.typenodes.SJTypeNode;
import sj.types.typeobjects.typeableinstances.SJMethodInstance;

public class SJMethodDeclExt_c extends Ext_c implements SJMethodDeclExt
{
	private SJTypeNode sjReturnType;
	private SJMethodInstance sjmi;

	public List<SJFormal> sjFormals()
	{
		List<SJFormal> sjFormals = new ArrayList<SJFormal>();

		for (Object formal : ((SJMethodDecl) node()).formals())
		{
			if (formal instanceof SJFormal)
			{
				sjFormals.add((SJFormal) formal);
			}
		}

		return sjFormals;
	}

	public SJTypeNode sjReturnType()
	{
		return sjReturnType;
	}

	public SJMethodDecl sjReturnType(SJTypeNode sjReturnType)
	{
		this.sjReturnType = sjReturnType;

		return (SJMethodDecl) node();
	}

	public SJMethodInstance sjMethodInstance()
	{
		return sjmi;
	}

	public SJMethodDecl sjMethodInstance(SJMethodInstance sjmi)
	{
		this.sjmi = sjmi;

		return (SJMethodDecl) node();
	}
}
