/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.extension.protocoldecls;

import sj.ast.protocoldecls.*;
import sj.ast.typenodes.SJTypeNode;
import sj.extension.*;
import sj.types.typeobjects.typeableinstances.SJNamedInstance;

public class SJProtocolDeclExt_c extends SJNamedExt_c implements SJProtocolDeclExt
{
	private SJTypeNode sjTypeNode;

	public SJProtocolDeclExt_c(SJTypeNode sjTypeNode)
	{
		this.sjTypeNode = sjTypeNode;
	}

	public SJTypeNode sjTypeNode()
	{
		return sjTypeNode;
	}

	public SJProtocolDecl sjTypeNode(SJTypeNode sjTypeNode)
	{
		this.sjTypeNode = sjTypeNode;

		return (SJProtocolDecl) node();
	}

	public String sjTypeableName()
	{
		SJProtocolDecl pd = (SJProtocolDecl) node();

		if (pd instanceof SJFieldProtocolDecl)
		{
			return ((SJFieldProtocolDecl) pd).name();
		}
		else //if (pd instanceof SJFieldProtocolDecl)
		{
			return ((SJLocalProtocolDecl) pd).name();
		}
	}

	public SJProtocolDecl sjTypeableName(String sjTypeableName)
	{
		SJProtocolDecl pd = (SJProtocolDecl) node();

		if (pd instanceof SJFieldProtocolDecl)
		{
			return (SJFieldProtocolDecl) ((SJFieldProtocolDecl) pd).name(sjTypeableName);
		}
		else //if (pd instanceof SJFieldProtocolDecl)
		{
			return (SJLocalProtocolDecl) ((SJLocalProtocolDecl) pd).name(sjTypeableName);
		}
	}

	public SJProtocolDecl sjNamedInstance(SJNamedInstance sjni)
	{
		return (SJProtocolDecl) super.sjNamedInstance(sjni);
	}
}
