/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.extension.sessops;

import java.util.List;

import polyglot.ast.*;

import sj.ast.sessops.SJSpawn;
import sj.types.typeobjects.typeableinstances.SJThreadInstance;

public interface SJSpawnExt extends Ext // In terms of functionality (both can "delegate" multiple sessions), this could be a base class for SJCallExt. But that wouldn't match the (lack of a strong) relationship between the corresponding AST nodes.
{
	public List<Receiver> socketArgs(); // Based on SJCallExt but some Polyglot problems adding the socket Receivers to the target New arguments in the original parse pass. So only becomes a list of SJLocalSocket after SJSessionOperationParser pass.
	public SJSpawn socketArgs(List<Receiver> socketArgs);

	public SJThreadInstance sjThreadInstance(); // Based on SJCallExt.
	public SJSpawn sjThreadInstance(SJThreadInstance sjti);
}
