/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.extension.sessops;

import java.util.List;

import polyglot.ast.*;

import sj.ast.sessops.SJSpawn;
import sj.types.typeobjects.typeableinstances.SJThreadInstance;

public class SJSpawnExt_c extends Ext_c implements SJSpawnExt // Could be unified with SJSessionOperationExt when the latter is generalised to be performed on multiple sessions. On the other hand, may be better to think of spawn as an operation on no session (local system operation) that takes multiple session arguments.
{
	private List<Receiver> socketArgs;
	private SJThreadInstance sjti;

	public SJSpawnExt_c(List<Receiver> socketArgs)
	{
		this.socketArgs = socketArgs;
	}

	public List<Receiver> socketArgs()
	{
		return socketArgs;
	}

	public SJSpawn socketArgs(List<Receiver> socketArgs)
	{
		this.socketArgs = socketArgs;

		return (SJSpawn) node();
	}

	public SJThreadInstance sjThreadInstance()
	{
		return sjti;
	}

	public SJSpawn sjThreadInstance(SJThreadInstance sjti)
	{
		this.sjti = sjti;

		return (SJSpawn) node();
	}
}
