/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.extension.sessops.structuralops;

import polyglot.ast.*;

import sj.ast.sessvars.SJSocketVariable;
import sj.ast.sessops.structuralops.SJStructuralOperation;
import sj.extension.sessops.SJSessionOperationExt_c;

public class SJStructuralOperationExt_c extends SJSessionOperationExt_c implements SJStructuralOperationExt
{
	private Receiver target;

	public SJStructuralOperationExt_c(Receiver target)
	{
		this.target = target;
	}

	public Receiver target()
	{
		return target;
	}

	public SJStructuralOperation target(Receiver target)
	{
		this.target = target;

		return (SJStructuralOperation) node();
	}

	public String session()
	{
		return ((SJSocketVariable) target).name(); // Never called until after session operation "parsing".
	}
}
