/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.types.typeobjects.sesstypes; // Rename to sesstypes?

import polyglot.types.SemanticException;
import polyglot.types.Type;

import sj.types.*;
import sj.types.typeobjects.SJTypeObject;

/**
 * A SJType holds the information of a session type element.
 */
public interface SJType extends Type, SJTypeObject // Rename back to SJType.
{
	public SJTypeSystem typeSystem();

	public SJType child();
	public SJType child(SJType child);
	public SJType parent(); // Not preserved by cloning. // Currently unused.

	//public SJType leaf();
	public SJType append(SJType sjType);

	//public boolean isSubtype(Type t); // Already declared for Type.
	public boolean isDualtype(Type t);
	public SJType subsume(SJType sjType) throws SemanticException;
	public boolean wellFormed();

	public boolean nodeEquals(SJType sjType);
	public boolean nodeSubtype(SJType sjType); // Should check SVUID values?
	public boolean nodeDualtype(SJType sjType); // Should check SVUID values?
	public SJType nodeSubsume(SJType sjType) throws SemanticException;
	public boolean nodeWellFormed();

	public boolean treeEquals(SJType sjTree); // typeEquals uses this.
	public boolean treeSubtype(SJType sjTree);
	public boolean treeDualtype(SJType sjTree);
	public SJType treeSubsume(SJType sjTree) throws SemanticException;
	public boolean treeWellFormed();

	public SJType nodeClone();
	public SJType treeClone();

	public String nodeToString();
	public String treeToString();
}
