/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.types.typeobjects.sesstypes;

import polyglot.types.*;

import sj.SJConstants;

public class SJUnknownType extends SJType_c implements SJType
{
	public static final long serialVersionUID = 1L;

	public SJUnknownType(TypeSystem ts)
	{
		super(ts);
	}

	// Move default node methods to SJType_c? Are these suitable default values?
	public boolean nodeEquals(SJType jstType)
	{
		return false;
	}

	public boolean nodeSubtype(SJType jstType)
	{
		return false;
	}

	public boolean nodeDualtype(SJType jstType)
	{
		return false;
	}

	public boolean nodeWellFormed()
	{
		return true;
	}

	public SJType nodeClone()
	{
		return typeSystem().SJUnknownType();
	}

	public SJType nodeSubsume(SJType sjt) throws SemanticException
	{
		if (!(sjt instanceof SJUnknownType))
		{
			throw new SemanticException("Not subsumable: " + this + ", " + sjt);
		}

		return typeSystem().SJUnknownType();
	}

	public String nodeToString()
	{
		return SJConstants.SJ_STRING_UNKNOWN_TYPE;
	}
}
