/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.types.typeobjects.typeableinstances;

import sj.types.typeobjects.SJTypeObject;
import sj.util.SJMap;

// Maybe not in the most appropriate subpackage as this instance object is not actually for SJTypeable AST nodes.
public interface SJProcedureInstance extends SJTypeObject // Simplified SJ version of Polyglot instances.
{
	public String name(); // Recorded, unlike Polyglot procedure instances.
	public SJProcedureInstance name(String name);

	public SJMap sjFormals(); // SJMap preserves original insertion order.
	public SJProcedureInstance sjFormals(SJMap sjFormals);
}
