/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.types.typeobjects.typeableinstances;

import java.util.Set;

import polyglot.util.Position;

import sj.types.SJTypeSystem;
import sj.types.typeobjects.SJTypeObject_c;
import sj.types.typeobjects.sesstypes.SJType;
import sj.util.SJMap;

public class SJSessionTryInstance_c extends SJTypeObject_c implements SJSessionTryInstance
{
	public static final long serialVersionUID = 1L;

	private SJMap sockets;

	protected SJSessionTryInstance_c()
	{
		super();
	}

	public SJSessionTryInstance_c(SJTypeSystem ts, Position pos, SJMap sockets)
	{
		super(ts, pos);

		this.sockets = sockets;
	}

	public Set<String> sockets()
	{
		return sockets.keySet();
	}

	public SJType socketType(String name)
	{
		return sockets.get(name);
	}
}
