/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.util;

import java.io.IOException;

import polyglot.types.SemanticException;
import polyglot.util.TypeEncoder;

import sj.SJConstants;
import sj.types.SJTypeSystem;
import sj.types.typeobjects.sesstypes.SJType;

public class SJTypeEncoder
{
	//private SJTypeSystem sjts;
	private TypeEncoder te;

	public SJTypeEncoder(SJTypeSystem sjts)
	{
		//this.sjts = sjts;
		this.te = new TypeEncoder(sjts);
	}

	public String encode(SJType sjType) throws SemanticException
	{
		try
		{
			return te.encode(sjType);
		}
		catch (IOException ioe)
		{
			throw new SemanticException(ioe);
		}
	}

	public SJType decode(String encoded) throws SemanticException
	{
		try
		{
			return (SJType) te.decode(encoded, SJConstants.POLYGLOT_TYPEDECODER_NAME_ARG);
		}
		catch (IOException ioe)
		{
			throw new SemanticException(ioe);
		}
	}
}
