/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.visit.contexts;

import sj.types.typeobjects.typeableinstances.*;

public interface SJContextElement
{
	public void addProtocol(SJNamedInstance sjni);
	public void addChannel(SJNamedInstance sjni);
	public void addSocket(SJNamedInstance sjni);
	public void addServer(SJNamedInstance sjni);

	public boolean hasProtocol(String name);
	public boolean hasChannel(String name);
	public boolean hasSocket(String name);
	public boolean hasServer(String name);

	public SJNamedInstance getProtocol(String name);
	public SJNamedInstance getChannel(String name);
	public SJNamedInstance getSocket(String name);
	public SJNamedInstance getServer(String name);
}
