/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.visit.contexts.sesscontexts;

import polyglot.types.SemanticException;

import sj.types.typeobjects.sesstypes.SJType;

public class SJSessionOperationContext_c extends SJSessionContext_c implements SJSessionOperationContext
{
	private String session;

	public SJSessionOperationContext_c(String session, SJType sjType, SJSessionContext sjsc) throws SemanticException
	{
		super(sjsc); // Session contexts have no sessions in scope by default.

		this.session = session;

		openSession(session, sjType); // 'session' is now in scope.
	}

	public String session()
	{
		return session;
	}
}
