/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.visit.contexts.sesscontexts;

import java.util.*;

public class SJSessionTryContext_c extends SJSessionContext_c implements SJSessionTryContext
{
	private Set<String> sockets;

	public SJSessionTryContext_c(Set<String> sockets)
	{
		this.sockets = sockets;
	}

	public SJSessionTryContext_c(Set<String> sockets, SJSessionContext sjce)
	{
		super(sjce);

		this.sockets = sockets;
	}

	public Set<String> sockets()
	{
		return sockets;
	}

	public boolean socketSpecified(String socket)
	{
		return sockets().contains(socket);
	}
}
