/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.runtime;

import java.io.Serializable;
import java.net.InetSocketAddress;

public class SJServerAddress implements Serializable
{
	public static final long serialVersionUID = 1L;

	private SJProtocol protocol;
	private InetSocketAddress isa;

	private SJServerAddress(SJProtocol protocol, InetSocketAddress isa)
	{
		this.protocol = protocol;
		this.isa = isa;
	}

	public static SJServerAddress create(SJProtocol protocol, String hostname, int port)
	{
		return new SJServerAddress(protocol, new InetSocketAddress(hostname, port)); // Resolves hostname.
	}

	public static SJServerAddress create(SJProtocol protocol, InetSocketAddress isa)
	{
		return new SJServerAddress(protocol, isa); // Ok to alias address object?
	}

	public SJProtocol getProtocol()
	{
		return protocol;
	}

	public InetSocketAddress targetAddress()
	{
		return isa;
	}
}
