/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.runtime.net;

public class SJRSerializedMessage
{
	private boolean isBoolean = false;
	private boolean isInt = false;
	private boolean isByte = false;

	private byte[] sermsg = null;

	private boolean vboolean;
	private int vint;
	private byte vbyte;

	public SJRSerializedMessage(byte[] sermsg)
	{
		this.sermsg = sermsg;
	}

	public SJRSerializedMessage(boolean vboolean)
	{
		this.isBoolean = true;
		this.vboolean = vboolean;
	}

	public SJRSerializedMessage(int vint)
	{
		this.isInt = true;
		this.vint = vint;
	}

	public SJRSerializedMessage(byte vbyte)
	{
		this.isByte = true;
		this.vbyte = vbyte;
	}

	public boolean isPrimitive()
	{
		return sermsg == null;
	}

	public boolean isBoolean()
	{
		return isBoolean;
	}

	public boolean isInt()
	{
		return isInt;
	}

	public boolean isByte()
	{
		return isByte;
	}

	public byte[] objectMessage()
	{
		return sermsg;
	}

	public boolean booleanMessage()
	{
		return vboolean;
	}

	public int intMessage()
	{
		return vint;
	}

	public byte byteMessage()
	{
		return vbyte;
	}
}
