/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.runtime.net;

import java.io.Serializable;

public class SJStartDelegation implements Serializable
{
	public static final long serialVersionUID = 1L;

	private boolean origreq;
	private SJSocketParameters params;

	public SJStartDelegation(boolean origreq, SJSocketParameters params)
	{
		this.origreq = origreq;
		this.params = params;
	}

	public boolean originalRequestor()
	{
		return origreq;
	}

	public SJSocketParameters socketParameters()
	{
		return params;
	}

	public String toString()
	{
		return "SJStartDelegation";
	}
}
