/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.runtime.util;

import java.io.*;

public class SJObjectInputStream extends ObjectInputStream
{
	private SJRemoteClassLoader sjrcl;

	public SJObjectInputStream(InputStream in, SJRemoteClassLoader sjrcl) throws IOException
	{
		super(in);

		this.sjrcl = sjrcl;
	}

	 protected Class<?> resolveClass(ObjectStreamClass osc) throws IOException, ClassNotFoundException
	 {
		 return Class.forName(osc.getName(), true, sjrcl);
	 }
}
