package benchmarks.macro.socket;

import java.io.*;
import java.net.*;

public class SocketBenchmark {
    
    public SocketBenchmark(String server, int port) throws Exception {
        super();
        InetSocketAddress addr = new InetSocketAddress(server, port);
        Socket s = null;
        ObjectOutputStream oos = null;
        ObjectInputStream ois = null;
        int id = -1;
        long timeStarted = -1;
        long timeFinished = -1;
        try {
            s = new Socket(addr.getAddress(), addr.getPort());
            s.setTcpNoDelay(true);
            oos = new ObjectOutputStream(s.getOutputStream());
            ois = new ObjectInputStream(s.getInputStream());
            id = ((Integer) ois.readObject()).intValue();
            timeStarted = System.currentTimeMillis();
            oos.writeBoolean(true);
            oos.flush();
            Integer v = (Integer) ois.readObject();
            oos.writeBoolean(false);
            oos.flush();
            timeFinished = System.currentTimeMillis();
            System.out.println("Response time: " +
                               (timeFinished - timeStarted));
        }
        catch (Exception x) { x.printStackTrace(); }
        finally {
            System.out.println("Finished: " + id);
            close(ois, oos, s);
        }
    }
    
    public static void main(String[] args) throws Exception {
        new SocketBenchmark(args[0], Integer.parseInt(args[1]));
    }
    
    private void close(ObjectInputStream ois, ObjectOutputStream oos,
                       Socket s) {
        try {
            if (oos != null) {
                oos.flush();
                oos.close();
            }
            if (ois != null) ois.close();
            if (s != null) s.close();
        }
        catch (IOException ioe) {  }
    }
    
    final public static String jlc$CompilerVersion$jl = "2.2.3";
    final public static long jlc$SourceLastModified$jl = 1209049116473L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAI1WW2xURRiePbvddtvVXrgXaEspASRsjRei9MXKRRaWdG1R" +
       "pJYss2dn29OeGzNz\ntgsq0ZgI8mBiwFvi5cWExPAEUR800QS8+2D6IL5gYj" +
       "DGRCHyYCQGo//MnLOXs6XYZM5OZ77/fpn/\n7FXUxCjqcx3zyKTp8BQ/4hKW" +
       "ymLKSGGbiRnbBwc5fevam7PfHt+9Morax1G7YY9xzA19m2NzUubj\nKGkRK0" +
       "8oGy4USGEcddqEFMYINbBpHAWgY4+jLmZM2ph7lLBRwhyzJIBdzHMJlTKDww" +
       "xK6o7NOPV0\n7lDGUUdmGpfwoMcNczBjMD6UQfGiQcwCO4yOoUgGNRVNPAnA" +
       "pZnAikHJcXCnOAd4qwFq0iLWSUAS\nmzHsAke9YYqKxQN7AACkzRbhU05FVM" +
       "zGcIC6lEomticHxzg17EmANjkeSOGo+5ZMAdTiYn0GT5Ic\nR8vDuKy6AlRC" +
       "ukWQcLQkDJOcyhR1h2JWE62RePKfk9m/+jSpc4HoptC/CYh6QkSjpEgosXWi" +
       "CG94\nqdPpA94qDSEALwmBFWZ43YePZX79pFdhVs6DGclPE53n9JtbVq2eG/" +
       "45ERVqtLgOM0Qq1Fkuo5r1\nb4bKLuTi0gpHcZkKLj8d/fzAs++R3zTUkkZx" +
       "3TE9y06jBLEL2/x9M+wzhk3U6UixyAhPo5gpj+KO\n/B/cUTRMItwRg72L+Z" +
       "Tcl12EUDOsCKz9SP0lxAeiPeboM4Q/DG6asjCdSbFpju7jhHE2wag+kQ8u\n" +
       "2ISFdepMMImfaCQrC1l3zEYiYOaqcMmZkJ+7HLNAaE4/c+Xrp3fsefGEVkk6" +
       "X0uO1lfFpaS4lBKX\nColDkYiUs6zenSI+BVFGv58b6nhpM/tAQ9FxlDAsy+" +
       "M4bxIoP2yaziwp5LjMv86aXJcpBvmZzEOq\nQtbnTGAkSwP8V6KoP5yS1UJO" +
       "ww5Dns0d+/e7a7nZ8yJ7RLQXC+5KNYjdjNItuXHs4O5DJ/qjAjQb\nE2EB6M" +
       "Dtuef0ayf3nv/+m8sbqqnP0UBDRTZSiooKq5+ljk4K0LGq7F/7e9cfp5oefF" +
       "8T6ZOARsUx\npBdUfU9YRl1lDQVdSjhLy6C2okMtbIqroLW08inqzFZPZK60" +
       "yf2d4IAWWOAztNXPzTbxEZcd4tOp\nMkv4M2SD7IE3no/ffenjts+02nbZXt" +
       "NXxwhXxddZDcc+SgicX349e+qVq8eflLHwg8FR3PXypqGX\npX5LIhD7RfM0" +
       "gtTyxadf3fjmpSDYi6rchynFR0Ssy8/NrX7jC/wWNAkoVmYcJbIWNSlJk/y7" +
       "4BGQ\nlCIJU6rhssZelqWGBa2i5Peyl3ve/eX8ldHFWk3DX9vQc2tpVNOXrm" +
       "x1yyBhzUISJPripjVnj43+\nmFfNsKu+1nbYnnX/Oz+QjQ8l9XkqOQrPUuBA" +
       "8b1L7jcJB/s57xu/qGr8jrJOXNEOpZZ9PrmovXA/\n2SmeyCBxrfxTf154u7" +
       "VPBULQdEsRSLIZ8LlUlQhuwQerb/XMSPuPP3E9+QK+eFDzWd3LUYI77maT\n" +
       "lIhZVS7MZK98VQPt2vf3/rRzy5lnwtppIL53Qcqc3lla+Wh0yvgS2lil3hue" +
       "9XqiodpAQOFRAlOJ\nLUwSJ83Sjp5K4bXDWg9ru1942+ctPPHtl991qkY0sV" +
       "8PhcLkpLRwnBsfc1keKo/PRQeuax8tHZAt\nJ5bHTKkZnoIah5y62UXqmahY" +
       "tQJW722s2uy67oJ6i38fkNA0RzELOqFEDPpU98BhyTGUAo9URItX\nNQMr7Y" +
       "tO/z+HQtNpdqlRwjBxzqtUVMKiQdGskEVjOCk1jaRt1+PQOgi2AkR3PWLE4w" +
       "2QdgmxK6/r\n/JJRTS0d4KhJNx0VpMfLwCL0Los+uLxh3FZDod4/d2jDBbfz" +
       "KxXrYHCLw/RU9EyzJmlrEzjuUlI0\npPS4ejVc+TPD0bJbDAsiL+VG2jCt8D" +
       "CZdYTxYI38rcUd5qi1ihMn1J2nTyuvlv8Dul/iMGIMAAA=");
}
