package benchmarks.macro.socket;

import java.io.*;
import java.net.*;

public class SocketClient {
    
    public SocketClient(String server, int port) throws Exception {
        super();
        InetSocketAddress addr = new InetSocketAddress(server, port);
        Socket s = null;
        ObjectOutputStream oos = null;
        ObjectInputStream ois = null;
        int id = -1;
        try {
            s = new Socket(addr.getAddress(), addr.getPort());
            s.setTcpNoDelay(true);
            oos = new ObjectOutputStream(s.getOutputStream());
            ois = new ObjectInputStream(s.getInputStream());
            id = ((Integer) ois.readObject()).intValue();
            while (true) {
                oos.writeBoolean(true);
                oos.flush();
                Integer v = (Integer) ois.readObject();
                Thread.currentThread().sleep(2000);
            }
        }
        catch (Exception x) {  }
        finally {
            System.out.println("Finished: " + id);
            close(ois, oos, s);
        }
    }
    
    public static void main(String[] args) throws Exception {
        new SocketClient(args[0], Integer.parseInt(args[1]));
    }
    
    private void close(ObjectInputStream ois, ObjectOutputStream oos,
                       Socket s) {
        try {
            if (oos != null) {
                oos.flush();
                oos.close();
            }
            if (ois != null) ois.close();
            if (s != null) s.close();
        }
        catch (IOException ioe) {  }
    }
    
    final public static String jlc$CompilerVersion$jl = "2.2.3";
    final public static long jlc$SourceLastModified$jl = 1209049160950L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAI1WW2wUVRg+O7vddtvVbcu9QFtKCSBh6yWi2ITYNCALS7q2" +
       "eKGWLLOzZ9tp58Y5\nZ7YLKtGYCPpgYsBb4uXFhMTwBFEfNNEEvPtg+iC+YG" +
       "IwxkQh8mAkBqP/OWdmd3Z2KTaZ2dMz33//\nv/+cM1dQCyWo37GNI9OGzdLs" +
       "iINpOqcSioujhkrpftjIaw+svzH/7fE9q6MoNYlSujXBVKZro7bF\ncIVNoq" +
       "SJzQImdKRYxMVJ1GVhXJzARFcN/SgAbWsSdVN92lKZSzAdx9Q2yhzYTV0HE2" +
       "HT38yipGZb\nlBFXYzahDHVmZ9WyOuQy3RjK6pQNZ1G8pGOjSA+jYyiSRS0l" +
       "Q50G4PKsH8WQ0Di0i+8DvF0HN0lJ\n1bAvEpvTrSJDfWGJasSDewEAoq0mZj" +
       "N21VTMUmEDdUuXDNWaHppgRLemAdpiu2CFoZ6bKgVQm6Nq\nc+o0zjO0MozL" +
       "yU+ASoi0cBGGloVhQlOFoJ5QzQLVGosn/3kx91e/InwuYs3g/reAUG9IaByX" +
       "MMGW\nhqXgdTd9KnPAXaMgBOBlIbDEjGz48JHsr5/0SczqJpixwizWWF67sW" +
       "3N2oWRnxNR7kabY1Odt0Jd\n5KKqOe/LcMWBXlxe1cg/pv2Pn45/fuCZ9/Bv" +
       "CmrLoLhmG65pZVACW8VRb90K66xuYbk7VipRzDIo\nZoituC3+h3SUdAPzdM" +
       "Rg7ahsRqwrDkKoFZ4IPFkk/xL8xVBqwtbmMBs1dGyxNJ1l6C6GKaNTlGhT\n" +
       "BUjejKmSOTplqhqxp6gAT4VkKtzKbfORCAS4Jkw2Azpzt20UMclrpy9//dTO" +
       "vS+cUKrt5vnH0GDN\nVlrYSktb6aAtFIkIIyvqs8jLUuTs+f3scOdLW+kHCo" +
       "pOooRumi5TCwYG1qmGYc/jYp6JtusKtLjo\nLGjLZAE6FJo9b4AiwQhIW5mg" +
       "gXAn1vibgZUK7bVw7N/vrubnz/Gm4UVeyrVL16Bkc9K35OaJg3sO\nnRiIct" +
       "B8jFcDoIO31p7Xrr6479z331zaVOt4yFcDERslOZHC7ueIreEiDKqa+tf+3v" +
       "3HyZbt7yu8\naxIwn5gKXQVk7w3bqCPUsD+ceLKULOoo2cRUDf7JnyjtbIbY" +
       "87Ud0SgdYn07JKANHsgZus9ryQ7+\n4h87+atLthXPZygGMfquPxe/8+LHHZ" +
       "8pwSmZCozTCcwk57pq5dhPMIb9S6/nTr5y5fgTohZeMRiK\nO27B0LWK8G9Z" +
       "BGq/pAn/0yuXnnp185sX/WIvqWkfIUQ9wmtdeXZh7RtfqG/BbACOUv0oFhRU" +
       "hCVF\n6O+G2S8keROm5ZyljSMsR3QTJkTZG2Ev9777y7nL40uVwJxf3zBqgz" +
       "Jy1otUtjsVsLBuMQsCfWHL\nujPHxn8syBnYXc+1nZZr3vvOD3jzg0mtCY2j" +
       "cBr5CeTvO8R6C0+w1/Ne8Etqwe+saNjhU1B42e+J\nc+6Fh8kufjL6jWsWnv" +
       "zz/Nvt/bIQXKZHmEBCzaCnpeaE/xVysPZmp4uI//jj15LPqxcOKp6qexhK\n" +
       "MNvZauAyNmrOhZXsE4ep713qsb6fdm07/XTYOwXM9y0qmde6yqsfjs7oX8IY" +
       "q/K94TSvFxoOFgKI\nRzBcRiweEt9pFXH0VomXgmcjPNs94m1vSjz+HhDvDZ" +
       "IjCl9vBKJQcUFavM6NZ7igh+zjs9HBa8pH\nywfFyIkVVCrdDF9+Gu82dVcW" +
       "4WeiGtUqePpuEdVWx3EW9Zv/e7+AZhiKmTAJBWLIk7obNsu2Lh14\nqGo64R" +
       "2sOzzTO/5fQmHotDpEL6tw0WzqVFTAoj5pVgnS6HZaXkIyluMyGB1YNX1ETz" +
       "1izGUNkJSA\nWNWjtbllFODSAYZaNMOWRXq0wlAyeCjzIbiy4YotL4LawMKh" +
       "Teedrq9kof3LWhxuTCXXMAIdG+ze\nuENwSRem4/LIcMTPHEMrbnJN4E0pFi" +
       "KAWYmHC0NnGA+hiN8g7jBD7TUc3yFOkyEtU1r5D/m8/nNW\nDAAA");
}
