package benchmarks.micro.rmi;

import java.io.IOException;
import java.rmi.NotBoundException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import benchmarks.micro.BigObject;

public class RMIClient {
    
    public RMIClient(String rmiRegHost, String remoteObject, int msgSize,
                     int sessLen)
          throws Exception {
        super();
        dummyrun();
        Registry registry = LocateRegistry.getRegistry(rmiRegHost);
        RMIServer remoteServer = (RMIServer) registry.lookup(remoteObject);
        boolean foo = true;
        long timeStarted = System.nanoTime();
        for (int k = 0; k < sessLen; k++) {
            BigObject bo = null;
            if (msgSize == 100) {
                bo = remoteServer.getBigObject100(true);
            } else
                      if (msgSize == 10000) {
                          bo = remoteServer.getBigObject10000(true);
                      } else {
                          throw new RuntimeException("Bad BigObject size: " +
                                                     msgSize);
                      }
        }
        long timeFinished = System.nanoTime();
        System.out.println((timeFinished - timeStarted) / 1000);
    }
    
    public static void main(String[] args) throws Exception {
        new RMIClient(args[0], args[1], Integer.parseInt(args[2]),
                      Integer.parseInt(args[3]));
    }
    
    private void dummyrun() throws Exception {
        Registry registry = LocateRegistry.getRegistry("localhost");
        RMIServer dummy = (RMIServer) registry.lookup("dummy");
        BigObject dummybo = dummy.getDummy(true);
    }
    
    final public static String jlc$CompilerVersion$jl = "2.2.3";
    final public static long jlc$SourceLastModified$jl = 1209553088628L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAI1WW2xURRiePbvddstiaSm1Ar1QSgBJt14iik2ITQN2YQlr" +
       "i5fWkuXsObPtoXMu\nzszZblGJxsQiDyYGvCVeXkxIDE8Q9UETTcC7D6YP4g" +
       "smBmNMFCIPRmIw+s+cc3a3Z5fCJufsnJn/\nNv///d/M6cuogVHU69hkfprY" +
       "PMXnHcxSWZUyrI8QlbEDMJHTHtx4fe67hT3roqhlErUY1jhXuaGN\n2BbHJT" +
       "6JkiY285iyYV3H+iRqtTDWxzE1VGIcAUHbmkRtzJi2VO5SzMYws0lRCLYx18" +
       "FU+gwmMyip\n2Rbj1NW4TRlHqzKH1aI66HKDDGYMxocyKF4wMNHZU+goimRQ" +
       "Q4Go0yDYkQl2MSgtDu4W8yDebECY\ntKBqOFCJzRqWzlFPWKO84/69IACqjS" +
       "bmM3bZVcxSYQK1eSER1ZoeHOfUsKZBtMF2wQtHa29oFISa\nHFWbVadxjqPO" +
       "sFzWWwKphEyLUOFoTVhMWipRtDZUs6pq7Y8n/z2e/btXkTHrWCMi/gZQ6g4p" +
       "jeEC\nptjSsKd4zU2dTE+46xWEQHhNSNiTGd700aOZ3z7t8WTW1ZHZnz+MNZ" +
       "7Trm9f37U4/EsiKsJocmxm\nCCgs2bmsatZfGSo5gMWOskWxmAoWPxv7YuK5" +
       "9/HvCmpKo7hmE9e00iiBLX3EHzfCOGNY2JvdXygw\nzNMoRuRU3JbfkI6CQb" +
       "BIRwzGjspn5LjkIIQa4YnAM4q830rx4ig5ti89Qgxs8RQ7zNE2jhlnU4xq\n" +
       "U3nI3Iyp0lk2ZRoataeoaUxVS5eE8ZVzkQjsa324xwgActQmOqY57dSlb57Z" +
       "tfelY0oZZX5YHHVX\nvKSklxR4SZW9oEhEmr99adpEHXTRLn+cGVr18gD7UE" +
       "HRSZQwTNPlap5gaDOVEHsO6zkucdZahWkJ\nJcBhMg+QBHTnCBiSLQB5KlLU" +
       "F4ZepWHTMFIBT4tH//v+Sm7urECJqGq7sO6FBjWa9WJLbh0/uOfQ\nsb6oEJ" +
       "qLifSDaP/Nree0K8f3nf3h24tbKhDnqL+m82o1ReeEw89SW8M6MFPF/Ov/jP" +
       "55omHHB4qA\nSQIIiasAI+ju7rCPJR00FLCRSJaSQSsKNjVVIpYCCmnmM9Se" +
       "q8xIiKyQ49sgAU3wQM7Q/T4GW8RL\nLK4Sr1YPUCKfoT1Irrv2QvyuC5+s+F" +
       "yppsWWKv4cx9xrstZKOQ5QjGH+4hvZE69eXnhS1sIvBkdx\nx80TQyvJ+NZE" +
       "oPar6zR8qrP95Gtb37oQFHt1xfowpeq8qHXp+cWuN79U3wYygKZkxhEsey4m" +
       "PcWk\n/TYge6kpQJjyiFXMD7Ba4spSwwReKPrE9Ur3e7+evTTWrlSx+8Yagq" +
       "3W8Rhe5rPZKYGHDct5kNLn\nt204fXTsp7zHfG1LG26X5Zr3vfsj3vpQUqvT" +
       "xVE4g8TH3UEqxftOOd4mUu2j30/D6koadpU07AgC\nlKH2+uqiC8OEslscig" +
       "GEzfzTf517p7nXK4nQWStdIGmm37dSCSJYhUR03ehgkUlYeOJq8kX1/EHF\n" +
       "N3UvRwluOwMEFzGpBBc2sk+eo0F0LY/3/Lx7+6lnw9Ep4L5nWc2c1lpc90h0" +
       "xvgKCK3c+TUH+VKl\noepqQAtSDPcQS2xJzDTKfXSXW1C03GZ4dvgtuKNuC4" +
       "p3n3xv8rpFEePN0DJM3o2Wr3Pt8S0bxQPz\nmWj/VeXjjn5JPrG8yrwww/ee" +
       "2mvNktuKjDNR3tUd8PTcZFcDjuMsG7f4fECKpjmKmcCJUmLQ17oH\nJou24Q" +
       "XwcNl1Ap5OeHb6rnfeWkKBfhodahRVuGPWDQoFmL2liCc4atJd05ynriW+Hy" +
       "sBcsvHqKCt\nzppbsHdX0/oWD20557R+7RUkuE/F4VJTcAmpQlY1yuIOxQVD" +
       "uo57JO/IPzhr2+sd6cAR8Jbx657k\nDPBhWJKjBvlfLTfLUXNFTswQpw6het" +
       "ey0v+TK/xX8wsAAA==");
}
