package benchmarks.micro.rsocket;

import java.io.*;
import java.net.*;
import sj.types.typeobjects.sesstypes.*;
import sj.runtime.*;
import sj.runtime.net.*;
import benchmarks.micro.BigObject;

public class RServer {
    final private java.lang.String _sjprotocol_p =
      ("H4sIAAAAAAAAAFvzloG1uIhBpzhLr6SyILUYTOYnZaUmlxTrFacWF0NEg72c" +
       "UtMz80KAnPjk93O2\nu+vk/3vKxMBQUcSgTlArRBeTZNdU/VzjvUwMTD4MrM" +
       "kZmTkpJQzqPsVZ+mB1+ki69eG69SG6rX0Y\n2AoSi1LzSgoZ6hiYgLaKFuTn" +
       "VKbn5JdA7YbY4ai6PdTnxX55iMuksajxB9sQn/zHTEb2kuMTTmYG\nRh8Gjo" +
       "L84sySzPy8EgYJH5gm/dKSzBz9AKiMdUVBQQUwoPQI+tYzrxzot1SIg5yvT9" +
       "zwVtxNiQlk\nDUtSfkolxAMgkrEAaCbQSG2CRgan5qVAzAtk0T+l0hM6ERiI" +
       "XsCIKyvNTPFh4M4Fqk1MB1tZwiCK\n8AEkCMEBCLcRRHP8hwKg7TJogRSQk5" +
       "ic6pGfk5JaFJ+8/PGpGlfvzg6I8/MSc4HmC/lkJZYl6uck\n5qXrB5cUZeal" +
       "A8OmhEEqKTUvOSM3sSi7WC83M7koX88pMx0S2gUABaRE4mUCAAA=");
    final private static int[] msgSizes = { 100, 10000 };
    final private static int[] sessLens = { 0, 1, 10, 100, 1000 };
    final private SJProtocol p = new sj.runtime.SJProtocol(this._sjprotocol_p);
    private ServerSocket dummy = null;
    
    public RServer(int port) throws Exception {
        super();
        this.dummy = new ServerSocket(port + 1);
        SJRServerSocket ss = SJRServerSocket.create(p, port);
        int run = 0;
        int id = 0;
        while (true) {
            System.out.println("Run: " + run++);
            SJRSocket ds = null;
            SJRSocket s = null;
            for (int i = 0; i < msgSizes.length; i++) {
                for (int j = 0; j < sessLens.length; j++) {
                    {
                        sj.runtime.net.SJSocket _sjtryreturned_0 = null;
                        int _sjspawncount_ds = -1;
                        int _sjspawncount_s = -1;
                        try {
                            ds = ss.accept();
                            while (ds.insync()) {
                                ds.send(new BigObject(-1, msgSizes[i] - 86));
                            }
                            s = ss.accept();
                            while (s.insync()) {
                                s.send(new BigObject(id++, msgSizes[i] - 86));
                            }
                        }
                        finally {
                            if (ds != null && ds != _sjtryreturned_0)
                                ds.close(_sjspawncount_ds);
                            if (s != null && s != _sjtryreturned_0)
                                s.close(_sjspawncount_s);
                        }
                    }
                }
            }
        }
    }
    
    public static void main(String[] args) throws Exception {
        new RServer(Integer.parseInt(args[0]));
    }
    
    final public static String jlc$CompilerVersion$jl = "2.2.3";
    final public static long jlc$SourceLastModified$jl = 1209388037111L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAIVXW2xURRie3W233VLsjVYspS2lBJB0iw82ak2kqSUUlrR0" +
       "KUgtWc6eM7s97bk5\nM7vdViUaE8FLNAreEoUXExLDg4GoDxo1Ae+amD6AL5" +
       "AYjDFRiDwYicHoPzPn7OXsUprMdHbm/+e/\nff8//zl9FVVTgrod21hIGzaL" +
       "sgUH0+i4QijWhg2F0r2wkVAfWH9z/vsjO9eEUMMUatCtOFOYrg7b\nFsM5No" +
       "XqTWwmMaFDmoa1KdRkYazFMdEVQ18EQtuaQs1UT1sKyxBMJzC1jSwnbKYZBx" +
       "Mh09uMoXrV\ntigjGZXZhDLUGJtVskp/hulGf0ynbDCGwikdGxp9DB1GgRiq" +
       "ThlKGgjbYp4V/eLG/u18H8jrdFCT\npBQVeyxVc7qlMdTl58hb3LsLCIC1xs" +
       "Rsxs6LqrIU2EDNUiVDsdL9cUZ0Kw2k1XYGpDDUfstLgajW\nUdQ5JY0TDK32" +
       "043LI6CKCLdwFoZa/WTiphxB7b6YFUVrLFz/7/Pjf3cHhc4aVg2ufzUwdfqY" +
       "JnAK\nE2ypWDLeyESPjx7IdAQRAuJWH7GkGdrw0WTst8+6JM2aCjRjyVmsso" +
       "R6c6Bj7dLQL5EQV6PWsanO\noVBiuYjquHsymHMAi235G/lh1Dv8fOLLA0+9" +
       "h38PotpRFFZtI2NaoyiCLW3YXdfAOqZbWO6OpVIU\ns1FUZYitsC1+gztSuo" +
       "G5O6pg7ShsRqxzDkKoBkYAxiSSf418YqhuAqCcxSRKZxnqY5gyOk2JOp0E\n" +
       "v82YCpmj06auEnuaUFudw2y6QJ/jl6+cDwTArg5/jhkAyB22oWGSUE9d+faJ" +
       "kV3PHQ3mUeaqxVB3\nQU5UyIm6cqKuHBQICAF3ljqOR0LjCfPHmcHGl/roh0" +
       "EUmkIR3TQzTEkaGBJNMQx7HmsJJpDWVIRq\nASZAYn0SQAn4ThhwkUgC8FSW" +
       "oB4/+AopOworBRC1dPi/H68l5s9ynPC4ruK3S9UgSnNSt/rN8YM7\nDx3tCX" +
       "Gi+SoeACDtvf3tCfXa87vPXvju0qYCyBnqLcu9ck6eO371x4mtYg1qU+H6N/" +
       "7Z8eex6vs/\nCHKgRKAkMQWABPnd6ZdRkkODXj3izgrG0IqUTUzF4EdeEalj" +
       "M8SeL+wIkKwQ6zvAAbUwwGdozEVh\nN5/4YSOfmiSkuD99Nohqd+OZ8NaLn6" +
       "z4IlhcGBuKKmgcM5lmTYVw7CUYw/6lN8ePvXb1yKMiFm4w\nGAo7maShqzmh" +
       "X2sAYt9SIeWjq1cdf33z2xe9YLcUbh8iRFngsc49vbT2ra+Ud6AcQFpSfRGL" +
       "rAvk\nw+4vTuNENyH3s25xeqXz3V/PXplYFSyq4OvLimgxj6ziwmN1Tg4krF" +
       "tOgqA+v2Xd6cMTl5OyujWX\nptSIlTHvPfkT3rytXq2QqSF4Zzw/8flusd5S" +
       "ZCP/3cxc7/BEi47kVOzw+ia07HbZeYr568V2/uZ5\n+DSTj/917kRdt/Q352" +
       "kXIqoquLGEMaEufjp54sYP7LIwoABsfkdXrlzsPqUo5+67kG0Kv3/SDKKa\n" +
       "KdQo3mnFYvsUI8MBNAUvLR12N2NoZcl56aspn4jBfOJ2+ONYJNafUgWnw5pT" +
       "83WNL4vaYAzAaHaz\nqNmXRQHk8MU2wdAj5g0S8yEG4nRLAa1qHKJnFQa6h6" +
       "loeHIM1Zo0HQfsUlr+BAuoS7CeCfVeD37c\n1ivKR1VSoVJLf+9S3pqUdBzC" +
       "qIgj/vVXRNODjmfKrnJTgnz9MJ82guZhA1tp+d7182k0l78xKMkr\n4HPYsC" +
       "3MnwvvTJZx3Y7m+zs4zJXpRlCXzzm7hV0FLDVl1+wJzehfw7OUh0FZQ1bKNF" +
       "ga/DqCoZ+0\n9pZAoFN6a5RPvRWTEQkVUeVM9Q757/2ABJXb79neWPCLBLBb" +
       "jEUgSqD3EIwWF3otlaGXqAC9fLxG\n+LSdw40C0mLYonmjVubjHhD3aMvFfQ" +
       "SuCDie/q10NkoyFtNNHI3vhEeP2dBIVbIhAmM9jE7Xhs7K\nNsyWyw54Yqu1" +
       "jGku5EUL11nQtcimJS5aGCE6VxQqVIhGuxcmgtbeqtUVJfvII9frn1XOHwy6" +
       "YbuH\noQiznT4DZ7FRqKf+S0qh1bC/6+ftA6ee9BdUmWWTecc0wNgIY4/rmD" +
       "0VX+fKEdkog3rbF2JHXtpd\nMLqWkVYBmPJ7xHGcZeXwnwNC2UWGqkx4AQRF" +
       "n8u1FTaztq5BGGvcLpO/6qvLPhPlx4zas3Ro0zmn\n6RtZ7bwPjjB0/amMYR" +
       "TX66J12CE4pQslwrJ6y9R9Eb4QbtXzgj7uSuj5guR4GTzg5wAAiv/FdK9C\n" +
       "M1+g4zvHBIwP5v4HF9wcBQgPAAA=");
}
