package benchmarks.ticketagency.socket;

import java.io.*;
import java.net.*;
import java.util.*;
import sj.runtime.*;
import sj.runtime.net.*;
import benchmarks.ticketagency.Address;

class SAgency {
    
    SAgency(int port_a, String addr_s, int port_s) throws Exception {
        super();
        ServerSocket ss = null;
        try {
            ss = new ServerSocket(port_a);
            while (true) {
                Socket s1 = null;
                ObjectInputStream ois1 = null;
                ObjectOutputStream oos1 = null;
                try {
                    s1 = ss.accept();
                    s1.setTcpNoDelay(true);
                    ois1 = new ObjectInputStream(s1.getInputStream());
                    oos1 = new ObjectOutputStream(s1.getOutputStream());
                    double v = 1.0;
                    for (boolean redo = ois1.readBoolean(); redo;
                         redo = ois1.readBoolean()) {
                        String m = (String) ois1.readObject();
                        oos1.writeObject(new Double(v++));
                        oos1.flush();
                    }
                    String lab = (String) ois1.readObject();
                    if (lab.equals("ACCEPT")) {
                        Socket s2 = null;
                        ObjectInputStream ois2 = null;
                        ObjectOutputStream oos2 = null;
                        try {
                            s2 = new Socket(addr_s, port_s);
                            s2.setTcpNoDelay(true);
                            oos2 = new ObjectOutputStream(s2.getOutputStream());
                            ois2 = new ObjectInputStream(s2.getInputStream());
                            oos2.writeObject(ois1.readObject());
                            oos2.flush();
                            oos1.writeObject(ois2.readObject());
                            oos1.flush();
                        }
                        finally {
                            close(oos2, ois2, s2);
                        }
                    }
                }
                finally {
                    close(oos1, ois1, s1);
                }
            }
        }
        finally {
            if (ss != null) { ss.close(); }
        }
    }
    
    public static void main(String[] args) throws Exception {
        new SAgency(Integer.parseInt(args[0]), args[1],
                    Integer.parseInt(args[2]));
    }
    
    private void close(ObjectOutputStream oos, ObjectInputStream ois,
                       Socket s) {
        try {
            if (oos != null) {
                oos.flush();
                oos.close();
            }
            if (ois != null) ois.close();
            if (s != null) s.close();
        }
        catch (IOException ioe) {  }
    }
    
    final public static String jlc$CompilerVersion$jl = "2.2.3";
    final public static long jlc$SourceLastModified$jl = 1209508935615L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAI1WXWxURRSe/emWLavtlv8CbSlFqcqWhIjRvtgQGgpLurb4" +
       "Qy0ss3dnt7e9f8zM\n3W5RG42JIA8mBvxL/HkxITE8QdQHTTQB/30wfRBfMD" +
       "EYY6IQeTASg9EzM/fuz92l2OTezs49Z86Z\nc77vnHP2KmphFPU6tjFfNGye" +
       "4vMOYakMpozkdxmYsQOwkdUe2nxz7tvje9dHUPskatetCY65ru2y\nLU7KfB" +
       "IlTGLmCGXD+TzJT6KkRUh+glAdG/oxELStSdTJ9KKFuUsJGyfMNkpCsJO5Dq" +
       "HSpr+ZRgnN\nthinrsZtyjjqSM/gEh50uW4MpnXGh9IoVtCJkWdH0QIKpVFL" +
       "wcBFEFyd9m8xKE8cHBH7IN6mg5u0\ngDXiq0RndSvPUU9Qo3Lj/n0gAKqtJu" +
       "HTdsVU1MKwgTqVSwa2ioMTnOpWEURbbBescNR1y0NBaJmD\ntVlcJFmO1gbl" +
       "MuoTSMVlWIQKR6uCYvKkMkVdgZzVZGsslvjnZOav3rD0OU80Q/jfAkrdAaVx" +
       "UiCU\nWBpRijfc1OnRg+6GMEIgvCogrGSGt3z4aPrXT3qUzPomMmO5GaLxrH" +
       "Zz54aNi8M/xyPCjWWOzXQB\nhbqby6xmvC9DZQewuLpyoviY8j9+Ov75wWff" +
       "I7+F0bJRFNNswzWtURQnVn6Xt26FdVq3iNodKxQY\n4aMoasitmC1/QzgKuk" +
       "FEOKKwdjCfluuyg9RfCJ6j3rpdvDhqmxguQojmU2yGox2cMM6mGNWmcrA5\n" +
       "bWI6y6aAC7OEYyk2xWzxY6qqVRYm7pgLheB2G4JMMwCWe2wjT2hWO3Pl66d3" +
       "73vxRLiCNc85ju6q\nWkvVWkspaynPGgqFpJk19UEUWckL8vx+bqjjpW3sgz" +
       "CKTKK4bpouxzmDAOmwYdhzJJ/lEnXJGoRL\nYAEqEzkAKGA9a8BBkhAQtRJF" +
       "fUEgVuk7CisM6Fpc+Pe7a9m58wIzIscrxenKNcjYrPItMTBxaO+R\nE30RIT" +
       "QXFckA0f7bn57Vrp3cf/77by5vrQKeo/4GHjZqCh4F3c9QWyN5qFPV41/7e8" +
       "8fp1oefD8s\nQBOH8sQxgAq43h20UcenIb82iWCF02h5waYmNsQnv6C08Wlq" +
       "z1V3JFSWy/WdHhohZmjKQ2QSSXgu\noA7xSipgiXgG7iAr343nY9svfbz8s3" +
       "BtkWyvqaYThCvKJavpOEAJgf3Lr2dOvXL1+JMyFyoZqCzd\nWhWClK9owvrU" +
       "2pWnXx1485Kf4xXVQ4cpxfMixeXnFje+8QV+CyoCMJPpx4gkXkQaiLDG+pSh" +
       "ugn0\nL3n16eXud385f2V8ZbimiG9uqKO1OqqQy0C1OWWwsGkpC1L64r2bzi" +
       "6M/5hTBa6znkm7Lde8/50f\nyMDDCa0JTSPQamSYOqFxyQAICqVUkxD7KT+K" +
       "4j0g1/eIRHt491RXVFV3lzXiiAIo79DrqQveBUvJ\niGiKPmjN3FN/Xni7rV" +
       "dlQ+h0eVkU637vlKoT/leI0MZbNRYZneNPXE+8gC8eCntHbecozm1nm0FK\n" +
       "xKg6Fzxkv+yjvnftj/f8NLLzzDNB78JgvmdJzayWLK1/JDKtfwklrML1hkZe" +
       "rzRUmyYgHSUwh1ji\nSmKnVd6ju0I6UfbvhuewR7rDTUkn3n3yvUXxI8xRzH" +
       "Fzhq7Bgsn5aOlcN7ZwyROF9HOR/uvhj1b3\ny5ITzWGmXA3OPo2jTd3EIn2N" +
       "V262Dp6e29xsh+M4S/otfj4gRfdwFDWhEkqJ+zytQdgs2bpyYKRi\nOg5PGh" +
       "7NM639v6CGOGp1qF7CMGc2dcovHR5xuiRxdDulZpAxlzsuB/YRbPoi6+pFRq" +
       "0GiXYpYYmu\nKptrc8uohk8HOWrRDFsl6bEyOO31Y1EI1zYM12oE1PoWj2y9" +
       "4CS/Ujn2x7QYzEoF1zBqAFsL3phD\nSUGXVmOqWzjy3yx0o6VnBAFLuZBXmF" +
       "FqMI6tuYUaR4nan7VaR2EqqmqJHeo0KXsqwuX/AI1/KeVl\nDAAA");
}
