package benchmarks.ticketagency.socket;

import java.io.*;
import java.net.*;
import java.util.Date;
import sj.runtime.*;
import sj.runtime.net.*;
import benchmarks.ticketagency.Address;

class SCustomer {
    
    SCustomer(String addr_a, int port_a, int redo) throws Exception {
        super();
        int x = 0;
        while (x++ < redo) {
            Socket s = null;
            ObjectOutputStream oos = null;
            ObjectInputStream ois = null;
            long timeStarted = -1;
            long timeSinished = -1;
            try {
                timeStarted = System.currentTimeMillis();
                s = new Socket(addr_a, port_a);
                s.setTcpNoDelay(true);
                oos = new ObjectOutputStream(s.getOutputStream());
                ois = new ObjectInputStream(s.getInputStream());
                for (int i = 0; i < 10; i++) {
                    oos.writeBoolean(true);
                    oos.writeObject("travel");
                    oos.flush();
                    Double cost = (Double) ois.readObject();
                }
                oos.writeBoolean(false);
                oos.flush();
                oos.writeObject("ACCEPT");
                oos.writeObject(new Address("address"));
                oos.flush();
                Date d = (Date) ois.readObject();
                timeSinished = System.currentTimeMillis();
            }
            finally {
                System.out.println(timeSinished - timeStarted);
                close(oos, ois, s);
            }
        }
    }
    
    public static void main(String[] args) throws Exception {
        new SCustomer(args[0], Integer.parseInt(args[1]),
                      Integer.parseInt(args[2]));
    }
    
    private void close(ObjectOutputStream oos, ObjectInputStream ois,
                       Socket s) {
        try {
            if (oos != null) {
                oos.flush();
                oos.close();
            }
            if (ois != null) ois.close();
            if (s != null) s.close();
        }
        catch (IOException ioe) {  }
    }
    
    final public static String jlc$CompilerVersion$jl = "2.2.3";
    final public static long jlc$SourceLastModified$jl = 1209508996667L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAI1WXWxURRSe/emWLav9gRYo0JZSIlXZogkY7YtNQ9PCNl1b" +
       "/KGULHfvnW1ve/+Y\nmbvdohKNiSAPJgZETfx5MSExPEHUB000Af99MH0QXz" +
       "AxGGOiEHkwEoPRMzP37t69uxQ3uXfnzpwz\n58w533fmnLuGGihBPY5tLM0a" +
       "NkuzJQfTdFYhFGvDhkLpfpjIqY9svbX47fG9G2OoeRo169YUU5iu\nDtsWwy" +
       "U2jVImNvOY0CFNw9o0arUw1qYw0RVDPwqCtjWN2qg+aynMJZhOYmobRS7YRl" +
       "0HE2HTn8yg\nlGpblBFXZTahDLVk5pWiMuAy3RjI6JQNZlCioGNDo0fQMRTJ" +
       "oIaCocyCYEfGP8WA2HFghM+DeJMO\nbpKComJfJb6gWxpD3WGN8on79oEAqD" +
       "aamM3ZZVNxS4EJ1CZdMhRrdmCKEd2aBdEG2wUrDHXedlMQ\nWuUo6oIyi3MM" +
       "rQ/LZeUSSCVFWLgKQ+1hMbFTiaDOUM4C2ZpIpP45mf2rJyp81rBqcP8bQKkr" +
       "pDSJ\nC5hgS8VS8aabPj12wN0URQiE20PCUmZo24ePZ379pFvKbKwjM5Gfxy" +
       "rLqbd2b9q8PPRzMsbdWOXY\nVOdQqDq5yGrWWxksOYDFjvKOfDHtL346+fmB" +
       "597Dv0XRqjGUUG3DNa0xlMSWNuyNG2Gc0S0sZycK\nBYrZGIobYiphi28IR0" +
       "E3MA9HHMaOwubEuOQg+YvAc9Abt/AXQ6mpYZcy28QkTecZ2sUwZXSGEnUm\n" +
       "D5GbMxWyQGeADQuYQfosdWmG2vxjJqhX4mbuWoxE4ISbwmwzAJqjtqFhklPP" +
       "Xv36mT37XjoRLePN\nc5Ch7RV76aC9tLSXLttDkYgwtK46lDw3GqfQ7+cHW1" +
       "7eQT+Iotg0Suqm6TIlb2CgnmIY9iLWckxg\nrzWAcwEvwGYqDzAFxOcM2EjQ" +
       "AmJXJKg3DMcKicdgpADGlo/9+9313OIFjhye6bV8d+ka5G1B+pbq\nnzq09/" +
       "CJ3hgXWozzlIBo3513z6nXT45f+P6bK9srsGeor4aNtZqcTWH3s8RWsQbVqr" +
       "L9a3+P/nGq\n4eH3oxw6SShSTAFoAeO7wjaqWDXoVygerGgGrS7YxFQMvuSX" +
       "lSY2R+zFyowAy2oxvtvDJMQMjXi4\nbOMvvtjCX60SWjyeoTOI+nfzhcTOyx" +
       "+v/iwaLJXNgZo6hZkkXmslHfsJxjB/5fXsqVevHT8ociGT\ngUrCrfYIpHxN" +
       "He6n1689fab/zct+jtdUNh0iRFniKS49v7z5jS+Ut6AuAD+pfhQL+sWEgZjY" +
       "vw3q\nvtDk2EvLGktry1eW6CZUh6JXvl7peveXC1cn10YDNX5rTZkN6sg6Ly" +
       "LY5JTAwpaVLAjpS/dtOXds\n8se8rH9t1RTbY7nmrnd+wP2PptQ6DI7BTcQ/" +
       "dvpR5O9+Mb6XJ9rDuxeBNZUI7Cmp2OFlULja46lz\n3oWLyQi/Gn3Qmvmn/7" +
       "z4dlOPzAbX6fSyyMd93i4VJ/xVCMTm210vIgjHn7qRelG5dCjqbfUgQ0lm\n" +
       "OzsMXMRGxbnwJuPiNvW9a36y+6eR3WefDXsXBfPdK2rm1Nbixsdic/qXUMLK" +
       "XK+5zquVBoPZANIR\nDN2IxY/EZxrFObrKpGuG5x54Rj3SjdYlHX/3ivc2yY" +
       "8oQwnHzRu6CgMquqSVc117kQueSECfj/Xd\niH7U0SdKTjyvUOlquAOqbXCq" +
       "+hbha7J8sg3wdN/hZPc7jrOi3/zzISE6ylDchEooJNKe1gMwWbR1\n6cBI2X" +
       "QSngw8457p8f8X1AhDjQ7Riwp0m3WdCpWOTkEc3U7LTmTCZY7LoIhgxfRFNl" +
       "SLjFk1Es1C\nwuL3qrhe61tGAT4dYKhBNWyZpCdKQInyjcxL4fqaJlu2gmrv" +
       "8uHtF53Wr2SW/XYtAT1TwTWMAGSD\n8E04BBd0YTch7wtH/C3AfbRyn8CBKQ" +
       "biEPNSDdqydbdRgw4o+BnUOsJQU0WLzxCnTv2WMS79B+6O\n8thtDAAA");
}
