package benchmarks.ticketagency.socket;

import java.io.*;
import java.net.*;
import java.util.Date;
import benchmarks.ticketagency.Address;

class SService {
    
    public SService(int port) throws Exception {
        super();
        ServerSocket ss = null;
        try {
            ss = new ServerSocket(port);
            while (true) {
                Socket s = null;
                ObjectInputStream ois = null;
                ObjectOutputStream oos = null;
                try {
                    s = ss.accept();
                    s.setTcpNoDelay(true);
                    ois = new ObjectInputStream(s.getInputStream());
                    oos = new ObjectOutputStream(s.getOutputStream());
                    Address a = (Address) ois.readObject();
                    oos.writeObject(new Date());
                    oos.flush();
                }
                finally {
                    close(oos, ois, s);
                }
            }
        }
        finally {
            if (ss != null) { ss.close(); }
        }
    }
    
    public static void main(String[] args) throws Exception {
        new SService(Integer.parseInt(args[0]));
    }
    
    private void close(ObjectOutputStream oos, ObjectInputStream ois,
                       Socket s) {
        try {
            if (oos != null) {
                oos.flush();
                oos.close();
            }
            if (ois != null) ois.close();
            if (s != null) s.close();
        }
        catch (IOException ioe) {  }
    }
    
    final public static String jlc$CompilerVersion$jl = "2.2.3";
    final public static long jlc$SourceLastModified$jl = 1209508701140L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAI1WW2wUVRg+e+m22672AuVSSltKCSBhi4lisAmxISALS7q2" +
       "GKGULLMzZ9uhZy6e\nObPdohKNiUUeTAyImnh5MSExPEHUB000Ae8+mD6IL5" +
       "gYjDFRiDwYicHof86Z2Z2dXapNZnvmn/8/\n/+37LxduoCaHogHbIvPTxGJp" +
       "Nm9jJ51TqIO1XURxnINAyKsPr78z983CvjUx1D6J2nVzgilMV3dZ\nJsNlNo" +
       "lSBjYKmDqjmoa1SdRpYqxNYKorRD8BjJY5ibocfdpUmEuxM44di5Q4Y5fj2p" +
       "gKnT4xi1Kq\nZTqMuiqzqMNQR/a4UlKGXaaT4azusJEsShR1TDTnSXQSRbKo" +
       "qUiUaWBckfW9GBY3Du/hdGBv1cFM\nWlRU7IvEZ3VTY6g/LFHxeGg/MIBos4" +
       "HZjFVRFTcVIKAuaRJRzOnhCUZ1cxpYmywXtDDUc9dLganF\nVtRZZRrnGVoV" +
       "5svJT8CVFGHhIgx1h9nETWWKekI5C2RrLJH6+3Tuz4GosFnDKuH2N4FQX0ho" +
       "HBcx\nxaaKpeBtN302c9jtjSIEzN0hZskzuuGDx7O/fNwvedY04BkrHMcqy6" +
       "t3tveuXRz9KRnjZrTYlqNz\nKNR4LrKa876MlG3A4orKjfxj2v/4yfhnh599" +
       "F/8aRS0ZlFAt4hpmBiWxqe3yzs1wzuomltSxYtHB\nLIPiRJASlniHcBR1gn" +
       "k44nC2FTYjzmUbyb8IPFnvnOI/DLVNAJRLuorTznGGHmDYYc6UQ9WpAgRu\n" +
       "xlDorDMFxTCLGWTPVOenHIu/TAXEylzJPXORCPjXG641AsDcaxEN07x6/vpX" +
       "T+/e/+KpaAVtnnkM\nbayqSwfVpaW6tK8ORSJCz8raOPLEaLx+frs40vHSVu" +
       "f9KIpNoqRuGC5TCgRD3SmEWHNYyzMBvM4A\nyAW2AJipAmAU4J4ncJGoCQhc" +
       "iaLBMBarFZyBkwIAWzz5z7c383OXOGx4mpfz26VpkLRZaVtq88TR\nfcdODc" +
       "Y401yc5wNYh/779rx68/SBS999fW1TFfMMDdWVYr0kL6Ww+TlqqViDVlW9/t" +
       "W/9v5+pmnH\ne1GOmyR0KKYArqDc+8I6akpqxG9PPFjRLGorWtRQCP/k95RW" +
       "NkOtuSpFYKVNnO+FALTAAzFDD3mg\n5DTEP3bwn06JLB7PkA+i+d1+PrHt6k" +
       "dtn0aDfbI90FAnMJNV11lNx0GKMdCvvZY788qNhSMiF14y\nGErYboHoalnY" +
       "1x2B3C9r0AHSq5afPbf5jat+spdVbx+lVJnnuS4/t7j29c+VN6E7QJU6+gks" +
       "ijBS\nSXu4V+WobkArKHm96uW+d36+dH18eTTQ0NfX9dSgjGzqImKtdhk0rF" +
       "tKg+C+smXdhZPjPxRks+uq\nLandpms8+Pb3ePMjKbVBwcZg7Phx4r/3ifOW" +
       "gI/8vYt50eGFlt5dVrHN252wcsAT5yUWbht7+Aj0\n8WkUnvrj8lutAzLeXK" +
       "ZHqEDygkHxu8EO0rpR1aYKM0Vr7zZVRDgWDt1KvaBcOcr1cMH7GUoyy95K\n" +
       "cAmTqq3hSw6IIeob2/5E/497tp9/JmxsFNT3LymZVztLax6LzehfQPOqVHnd" +
       "FK8VGgnmBcqNYlhC\nTO4SpzQLP/oq5dYOz0Z4dnjltqNhudUFNcrPG6E8HL" +
       "EYLZ32+tktikLC+mJs6Fb0wxVDotHEC4oj\nzQwvPfU7Tc2qIuxMVrxaDU//" +
       "El75SOyoIlHuNbZtL+kLf90ulGUYihvQEwXHVk9qGxBLli6NerRi\nTtIbsj" +
       "s9c3b+vyBD+2m2qV5SYOlsaFRMsMV8b3qEN7qVlgvJmMtsl4FfWDF8ltW1LB" +
       "mzjqNdcJh8\nwIo521gz8iqIvx9hqEkllkzcoTJDLf5o5q1wVd2qLRdCdXDx" +
       "2KbLdueXMvH+0paAzanoEhJAcBDN\nCZvioi7UJuTgsMU/AwbT0vsCx6o4CB" +
       "+IFIOutfIuYgylgq9BKZgprVUpTmF2A0TJEJf/BaXkvuZz\nDAAA");
}
