//$ bin/sjc tests/src/TestRecursion.sj -d tests/classes/
//$ bin/sj -cp tests/classes/ TestRecursion

import java.util.*;

import sj.runtime.*;
import sj.runtime.net.*;

public class TestRecursion
{
	private protocol p2 { rec rmeth[!<int>.!{REDO: #rmeth, QUIT: }] }
	private protocol p1 { begin.@p2 }

	private protocol q2 { rec rmeth[!<String>.?{REDO: !<boolean>.#rmeth, QUIT: }] }
	private protocol q1 { begin.@q2 }

	public TestRecursion(String server, int port) throws Exception
	{			
		SJServerAddress c1 = SJServerAddress.create(p1, server, port);			
		SJSocket s1 = SJFSocket.create(c1);	
		
		SJServerAddress c2 = SJServerAddress.create(q1, server, port);					
		SJSocket s2 = SJFSocket.create(c2);
	
		try (s1, s2)
		{		
			s1.request(); 
			s2.request(); 
					
			rmeth(s1, s2);
					
		}
		finally
		{

		}	
	}	

	private protocol x1 { rec m1[?{A: !<int>.#m1, B: }]}
	private protocol x2 { rec m1[!{A: #m1, B: }]}
	
	private sessrec void m1(@x1 s1, @x2 s2) throws SJIOException
	{
		s1.inbranch()
		{
			case A:
			{			
				s2.outbranch(A)
				{
					s1.send(123);
				
					m1(s1, s2);					
				}				
			}
			case B:
			{
				s2.outbranch(B)
				{
					
				}							
			}
		}		
	}
	
	//void rmeth(@p2 s1, @q2 s2, !<int> s3) throws SJIOException
	private sessrec void rmeth(@p2 s1, @q2 s2) throws SJIOException
	{
		s2.send("ABC");
		s1.send(123);

		int i = 0;
	
		//if (i++ < 3)
		{
			s2.inbranch()
			{	
				case REDO:
				{
					s1.outbranch(REDO)
					{
						s2.send(true);						

						//rmeth(s1, s2, s3);
						rmeth(s1, s2);
					}
				}
				case QUIT:
				{
					s1.outbranch(QUIT)
					{			
						//s3.send(123);
						
						//return s2;
						return;
					}
				}
			}
		}
		/*else
		{
			s1.outbranch(QUIT)
			{
				s2.outbranch(QUIT)
				{
					return;
				}
			}
		}*/
	}
	
	private sessrec !<String>.!<boolean> m3(rec m3[?{L1: #m3, L2: !<String>}] s1, rec m3[!{L3: !<String>, L4: ?(int).#m3 }].!<boolean> s2, ?(int) s3) throws SJIOException
	{
		s1.inbranch()
		{
			case L1:
			{
				s2.outbranch(L4)
				{
					int x = s2.receiveInt();				
				
					return m3(s1, s2, s3);
				}
			}
			case L2:
			{							
				s2.outbranch(L3)
				{										
					s1.send("ABC");				

					int y = s3.receiveInt();				
					
					return s2;
				}															
			}
		}
	}
	
  private sessrec void X(rec X[ !<int>.rec Y[ ?{ L5: !<String>.#Y, L6: #X } ] ] s4) throws SJIOException
  {
    s4.send(123);

    Y(s4);
  }

  private sessrec void Y(rec Y[ ?{ L5: !<String>.#Y, L6: #X } ] s5) throws SJIOException
  {
  	s5.inbranch()
  	{
    	case L5:
    	{
    		s5.send("ABC");
    		
    		Y(s5);
    	}
    	case L6:
    	{
    		X(s5);
    	}
    }
  }
	
	/*private sessrec void Z (rec Z[ !<int>.rec Y[ ?{ L5: !<String>.#Y, L6: #Z } ] ] s) throws SJIOException
	//void Z (!<int> s) throws SJIOException
	{
		s.send(123);

    Y(s);
	}*/
	
	private sessrec !<int> m5(rec m5[].!<int> s) throws Exception
	{
		//m5(s);
		return s;
	}

	private sessrec !<int> m6(rec m6[#m6].!<String> s) throws Exception
	{
		return m6(s);
	}

  private sessrec void Z1(rec Z1[ !{A1: #Z1, B1: , C1: } ] s1, rec Z1[ !{A2: #Z1, B2: } ] s2) throws SJIOException
  {
    if (true)
    {
      s1.outbranch(A1)
      {
        s2.outbranch(A2)
        {
          Z1(s1, s2);
        }
      }
		}
		else if (true)
		{
      s1.outbranch(B1)
      {
      
      }
      
		  s2.outbranch(B2)
			{
				return; // Optional.
			}      
    }    
    else
    {
    	s2.outbranch(A2)
    	{
    		s1.outbranch(A1)
    		{
    			Z1(s1, s2);
    		}
    	}
    }
  }

	private class C
	{
		private protocol q { rec X2[ ?{A: #X2, B: } ] } 
		private protocol p { begin.@q } // '@' used to refer to 'q' (for parsing).

		public void foo() throws Exception
		{
			SJServerAddress c = SJServerAddress.create(p, "localhost", 8888);
			SJSocket s = SJFSocket.create(c);

			try (s)
			{
				s.request();

				// Start option 1.
				/*s.recursion(X2)      
				{
					s.inbranch()
					{
						case A: { s.recurse("X2"); }
						case B: { }
					}
				}*/
				// End option 1.

				// Start option 2.
				X2(s);
				// End option 2.
			}
			finally { }    
		}

		// Even if this method is not used, still ok to declare it.
		private sessrec void X2(@q s) throws SJIOException // 'q' as declared above.
		{
			s.inbranch()
			{
				case A: { X2(s); }
				case B: { return; }
			}    
		}
	}
	
	public static void main(String[] args) throws Exception
	{
		new TestRecursion(args[0], Integer.parseInt(args[1]));
	}
}
