//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/macro/fsocket/FClient.sj -d tests/classes/
//$ tests/src/benchmarks/macro/fsocket/fsocket.sh localhost 8888 100

package benchmarks.macro.fsocket;

import sj.runtime.*;
import sj.runtime.net.*;

public class FClient 
{
	private protocol p { begin.?(Integer).![?(Integer)]* }

	public FClient(String server, int port) throws Exception 
	{		
		SJServerAddress c = SJServerAddress.create(p, server, port);
		SJSocket s = SJFSocket.create(c);
		
		int id = -1;
		
		try (s) 
		{							
			s.request();	

			id = ((Integer) s.receive()).intValue();							

			s.outwhile (true)
			{	
				Integer v = s.receive();							

				//System.out.println("Received: " + v);
				
				Thread.currentThread().sleep(2000);
			}	
		}
		catch (Exception x) { }
		finally 
		{
			System.out.println("Finished: " + id);
		}													
	}

	public static void main(String args[]) throws Exception 
	{
		new FClient(args[0], Integer.parseInt(args[1]));
	}	
}
