//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/macro/socket/SocketClient.sj -d tests/classes/
//$ tests/src/benchmarks/macro/socket/socket.sh localhost 8888 100

package benchmarks.macro.socket;

import java.io.*;
import java.net.*;

public class SocketClient 
{
	public SocketClient(String server, int port) throws Exception 
	{		
		InetSocketAddress addr = new InetSocketAddress(server, port);					

		Socket s = null;
		ObjectOutputStream oos = null;
		ObjectInputStream ois = null;		
		
		int id = -1;
		
		try 
		{							
			s = new Socket(addr.getAddress(), addr.getPort());		
		
			s.setTcpNoDelay(true);	
			
			oos = new ObjectOutputStream(s.getOutputStream());
			ois = new ObjectInputStream(s.getInputStream());			

			id = ((Integer) ois.readObject()).intValue();

			//for (int k = 0; k < sessLen; k++)
			while (true)
			{
				oos.writeBoolean(true);		
				oos.flush();
				
				Integer v = (Integer) ois.readObject();							

				//System.out.println("Received: " + v);
				
				Thread.currentThread().sleep(2000);
			}
				
			//oos.writeBoolean(false);
			//oos.flush();		
		}
		catch (Exception x) { }
		finally 
		{
			System.out.println("Finished: " + id);
		
			close(ois, oos, s);
		}													
	}

	public static void main(String args[]) throws Exception 
	{
		new SocketClient(args[0], Integer.parseInt(args[1]));
	}	
	
	private void close(ObjectInputStream ois, ObjectOutputStream oos, Socket s)
	{
		try
		{
			if (oos != null) 
			{
				oos.flush();						
				oos.close();
			}
			if (ois != null) ois.close();			
			if (s != null) s.close();
		}
		catch (IOException ioe) { }	
	}		
}
