//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/micro/fsocket/FServer.sj -d tests/classes/
//$ bin/sj -cp tests/classes/ benchmarks.micro.fsocket.FServer 8888

package benchmarks.micro.fsocket;

import java.io.*;
import java.net.*;

import sj.types.typeobjects.sesstypes.*;

import sj.runtime.*;
import sj.runtime.net.*;

import benchmarks.micro.BigObject;

public class FServer 
{
	private static final int[] msgSizes = { 100, 10000 };
	private static final int[] sessLens = { 0, 1, 10, 100, 1000 };

	private protocol p 
	{
		begin
		.?[
			!<BigObject>
			//!<int>
		]*
	}		

	private ServerSocket dummy = null;
	
	public FServer(int port) throws Exception 
	{					
		this.dummy = new ServerSocket(port + 1);
	
		SJFServerSocket ss = SJFServerSocket.create(p, port);
		
		int run = 0;
		int id = 0;		

		while (true) 
		{
			System.out.println("Run: " + run++);
			
			SJFSocket ds = null;
			SJFSocket s = null;

			for (int i = 0; i < msgSizes.length; i++)
			{			
				for (int j = 0; j < sessLens.length; j++)
				{				
					//dummyrun(port);														
						
					try (ds, s) 
					{	
						ds = ss.accept();					
											
						ds.inwhile() // Dummy run.
						{
							ds.send(new BigObject(-1, msgSizes[i] - 86));
							//ds.send(123);
						}
					
						s = ss.accept(); // Actual run.
						
						s.inwhile() 
						{
							s.send(new BigObject(id++, msgSizes[i] - 86));
							//s.send(id++);
						}
					}
					finally 
					{ 

					}
					
					//System.out.println("Served size " + msgSizes[i] + ", length " + sessLens[j] + ".");					
				}
			}				
		}
	}

	public static void main(String[] args) throws Exception 
	{
		new FServer(Integer.parseInt(args[0]));
	}
	
	/*void dummyrun(int port) throws Exception
	{				
		SJServerAddress c = SJServerAddress.create(p, "foo", 1234);
		SJFSocket bar = SJFSocket.create(c);
			
		Socket s = null;
		ObjectInputStream ois = null;
		ObjectOutputStream oos = null;
	
		try 
		{					
			s = dummy.accept();						

			s.setTcpNoDelay(true);		
			
			ois = new ObjectInputStream(s.getInputStream());
			oos = new ObjectOutputStream(s.getOutputStream());			

			oos.writeObject(p.encodedSJType());
		
			SJType theirs = bar.decodeSJType((String) ois.readObject()); 
	
			if (!bar.protocolType().treeDualtype(theirs))
			{
				throw new IOException("Foo: " + theirs);
			}			
			
			while (ois.readBoolean()) 
			{			
				oos.writeObject(new BigObject(-1, 1000));						
				oos.flush();
			}
		}
		finally 
		{
			try
			{	
				if (oos != null) 
				{				
					oos.flush();						
					oos.close();				
				}	
				if (ois != null) ois.close();
				if (s != null) s.close();
			}			
			catch (IOException ioe) { }			
		}			
	}*/	
}
