//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/micro/socket/SocketClient.sj -d tests/classes/
//$ tests/src/benchmarks/micro/socket/socket.sh localhost 8888 100

package benchmarks.micro.socket;

import java.io.*;
import java.net.*;

import benchmarks.micro.BigObject;

public class SocketClient 
{
	public SocketClient(String server, int port, int msgSize, int sessLen) throws Exception 
	{		
		InetSocketAddress addr = new InetSocketAddress(server, port);					

		dummyrun(addr);

		Socket s = null;
		ObjectOutputStream oos = null;
		ObjectInputStream ois = null;		

		/*OutputStream os = null;
		InputStream is = null;*/
		
		long timeStarted = -1;		
		long timeFinished = -1;		

		try // Actual run.
		{					
			timeStarted = System.nanoTime();
		
			s = new Socket(addr.getAddress(), addr.getPort());		
		
			/*os = s.getOutputStream();
			is = s.getInputStream();*/
		
			s.setTcpNoDelay(true);			
			
			oos = new ObjectOutputStream(s.getOutputStream());
			ois = new ObjectInputStream(s.getInputStream());			

			for(int k = 0; k < sessLen; k++)
			{
				//oos.writeByte(2);
				oos.writeBoolean(true);		
				oos.flush();
				//os.flush();
				
				//ois.readByte();
				BigObject bo = (BigObject) ois.readObject();					
				//int v = ois.readInt();

				//System.out.println("Received: " + bo);
			}
			
			//oos.writeByte(2);			
			oos.writeBoolean(false);
			oos.flush();
			//os.flush();
			
			timeFinished = System.nanoTime();
		}
		finally 
		{
			close(ois, oos, s);
		}								

		//System.out.println("Object size " + msgSize + ", session length " + sessLen + ": " + Math.round(((float) (timeFinished - timeStarted)) / 1000.0) + "ms.");												
		System.out.println(Math.round(((float) (timeFinished - timeStarted)) / 1000.0));
	}

	public static void main(String args[]) throws Exception 
	{
		new SocketClient(args[0], Integer.parseInt(args[1]), Integer.parseInt(args[2]), Integer.parseInt(args[3]));
	}	

	void dummyrun(InetSocketAddress addr) throws Exception
	{
		Socket s = null;
		ObjectOutputStream oos = null;
		ObjectInputStream ois = null;	
	
		try 
		{					
			s = new Socket(addr.getAddress(), addr.getPort());		
		
			s.setTcpNoDelay(true);
			
			oos = new ObjectOutputStream(s.getOutputStream());
			ois = new ObjectInputStream(s.getInputStream());

			for(int k = 0; k < 1; k++)
			{
				oos.writeBoolean(true);		
				oos.flush();
								
				BigObject bo = (BigObject) ois.readObject();					
			}

			oos.writeBoolean(false);
			oos.flush();
		}
		finally 
		{
			close(ois, oos, s);
		}	
	}	
	
	private void close(ObjectInputStream ois, ObjectOutputStream oos, Socket s)
	{
		try
		{
			if (oos != null) 
			{
				oos.flush();						
				oos.close();
			}
			if (ois != null) ois.close();			
			if (s != null) s.close();
		}
		catch (IOException ioe) { }	
	}		
}
