//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/micro/socket/SocketServer.sj -d tests/classes/
//$ bin/sj -cp tests/classes/ benchmarks.micro.socket.SocketServer 8888 

package benchmarks.micro.socket;

import java.io.*;
import java.net.*;

import benchmarks.micro.BigObject;

public class SocketServer 
{
	private static final int[] msgSizes = { 100, 10000 };
	private static final int[] sessLens = { 0, 1, 10, 100, 1000 };	

	private ServerSocket ss = null;
	
	public SocketServer(int port) throws Exception 
	{			
		ss = new ServerSocket(port);
		
		int run = 0;
		int id = 0; // Actually, id and run are almost the same.

		Socket s = null;
		ObjectInputStream ois = null;
		ObjectOutputStream oos = null;

		/*InputStream is = null;
		OutputStream os = null;*/
		
		while (true) 			
		{														
			System.out.println("Run: " + run++);
		
			for (int i = 0; i < msgSizes.length; i++)
			{																									
				for (int j = 0; j < sessLens.length; j++)
				{		
					dummyrun();												
									
					try // Actual run.
					{					
						s = ss.accept();						

						/*os = s.getOutputStream();
						is = s.getInputStream();*/
						
						s.setTcpNoDelay(true);	
						
						ois = new ObjectInputStream(s.getInputStream());
						oos = new ObjectOutputStream(s.getOutputStream());			
						
						//ois.readByte();
						for (boolean redo = ois.readBoolean(); redo; ) 
						{													
							//oos.writeByte(1);
							oos.writeObject(new BigObject(id++, msgSizes[i] - 86));
							//oos.writeInt(123);
							oos.flush();
							//os.flush();
							
							//ois.readByte();
							redo = ois.readBoolean();
						}
					}
					finally 
					{
						close(oos, ois, s);
					}			
					
					//System.out.println("Served size " + msgSizes[i] + ", length " + sessLens[j] + ".");				
				}
			}		
		}
	}	

	public static void main(String[] args) throws Exception 
	{
		new SocketServer(Integer.parseInt(args[0]));
	}
	
	void dummyrun() throws Exception
	{
		Socket s = null;
		ObjectInputStream ois = null;
		ObjectOutputStream oos = null;
		
		try 
		{					
			s = ss.accept();						

			s.setTcpNoDelay(true);		
			
			ois = new ObjectInputStream(s.getInputStream());
			oos = new ObjectOutputStream(s.getOutputStream());			

			while (ois.readBoolean()) 
			{			
				oos.writeObject(new BigObject(-1, 1000));						
				oos.flush();
			}
		}
		finally 
		{
			close(oos, ois, s);
		}			
	}	
	
	private void close(ObjectOutputStream oos, ObjectInputStream ois, Socket s)
	{
		try
		{
			if (oos != null) 
			{
				oos.flush();						
				oos.close();
			}
			if (ois != null) ois.close();
			if (s != null) s.close();
		}
		catch (IOException ioe) { }	
	}
}
