//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/ticketagency/rsocket/RAgency.sj -d tests/classes/
//$ bin/sj -cp tests/classes/ benchmarks.ticketagency.rsocket.RAgency 9999 localhost 8888

package benchmarks.ticketagency.rsocket;

import java.util.*;

import sj.runtime.*;
import sj.runtime.net.*;

import benchmarks.ticketagency.Address;

class RAgency 
{
	RAgency(int port_a, String addr_s, int port_s) throws Exception 
	{
		protocol p_ac 
		{
		  begin.
		  ?[
		  	?(String).!<Double>
		  ]*.
		  ?{
		    ACCEPT: ?(Address).!<Date>,
		  	REJECT:
		  }
		}

		protocol p_as { begin.!<?(Address).!<Date>> } 

		SJServerSocket ss_ac = null;
		
		try
		{
			ss_ac = SJRServerSocket.create(p_ac, port_a);
		
			while (true) 
			{
				SJSocket s_ac = null;

				try (s_ac)
				{
					s_ac = ss_ac.accept();

					double v = 1.0;

					s_ac.inwhile() 
					{
						String m = s_ac.receive();

						s_ac.send(new Double(v++));
					}

					s_ac.inbranch() 
					{
						case ACCEPT: 
						{
							SJServerAddress c_as = SJServerAddress.create(p_as, addr_s, port_s);
							SJSocket s_as = SJRSocket.create(c_as);

							try (s_as)
							{
								s_as.request();

								s_as.send(s_ac); 
							}
							finally
							{
							
							}
						}
						case REJECT: 
						{

						}
					}
				}		
				finally
				{
				
				}
			}
		}
		finally
		{
			if (ss_ac != null)
			{
				ss_ac.close();
			}
		}
	}

	public static void main(String[] args) throws Exception 
	{
		new RAgency(Integer.parseInt(args[0]), args[1], Integer.parseInt(args[2]));
	}
}
