//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/ticketagency/socket/SAgency.sj -d tests/classes/
//$ bin/sj -cp tests/classes/ benchmarks.ticketagency.socket.SAgency 9999 localhost 8888

package benchmarks.ticketagency.socket;

import java.io.*;
import java.net.*;
import java.util.*;

import sj.runtime.*;
import sj.runtime.net.*;

import benchmarks.ticketagency.Address;

class SAgency 
{
	SAgency(int port_a, String addr_s, int port_s) throws Exception 
	{
		ServerSocket ss = null;
		
		try
		{		
			ss = new ServerSocket(port_a); 
		
			while (true) 
			{
				Socket s1 = null;
				ObjectInputStream ois1 = null;
				ObjectOutputStream oos1 = null;

				try
				{
					s1 = ss.accept();

					s1.setTcpNoDelay(true);	

					ois1 = new ObjectInputStream(s1.getInputStream());
					oos1 = new ObjectOutputStream(s1.getOutputStream());	

					double v = 1.0;

					for (boolean redo = ois1.readBoolean(); redo; redo = ois1.readBoolean()) 
					{
						String m = (String) ois1.readObject();

						oos1.writeObject(new Double(v++));
						oos1.flush();
					}

					String lab = (String) ois1.readObject();
					
					if (lab.equals("ACCEPT"))
					{
						Socket s2 = null;
						ObjectInputStream ois2 = null;
						ObjectOutputStream oos2 = null;

						try 
						{
							s2 = new Socket(addr_s, port_s);

							s2.setTcpNoDelay(true);	

							oos2 = new ObjectOutputStream(s2.getOutputStream());	
							ois2 = new ObjectInputStream(s2.getInputStream());							

							oos2.writeObject(ois1.readObject()); 
							oos2.flush();
							
							oos1.writeObject(ois2.readObject()); 
							oos1.flush();
						}
						finally
						{
							close(oos2, ois2, s2);
						}
					}
				}		
				finally
				{
					close(oos1, ois1, s1);
				}
			}
		}
		finally
		{
			if (ss != null)
			{
				ss.close();
			}
		}
	}

	public static void main(String[] args) throws Exception 
	{
		new SAgency(Integer.parseInt(args[0]), args[1], Integer.parseInt(args[2]));
	}

	private void close(ObjectOutputStream oos, ObjectInputStream ois, Socket s)
	{
		try
		{
			if (oos != null) 
			{
				oos.flush();						
				oos.close();
			}
			if (ois != null) ois.close();
			if (s != null) s.close();
		}
		catch (IOException ioe) { }	
	}		
}
