//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/ticketagency/socket/SCustomer.sj -d tests/classes/
//$ tests/src/benchmarks/ticketagency/socket/ticketagency.sh localhost 9999 100
//$ bin/sj -cp tests/classes/ benchmarks.ticketagency.socket.SCustomer localhost 9999 100

package benchmarks.ticketagency.socket;

import java.io.*;
import java.net.*;
import java.util.Date;

import sj.runtime.*;
import sj.runtime.net.*;

import benchmarks.ticketagency.Address;

class SCustomer 
{
	SCustomer(String addr_a, int port_a, int redo) throws Exception
	{
		int x = 0;

		while (x++ < redo)
		{
			Socket s = null;
			ObjectOutputStream oos = null;
			ObjectInputStream ois = null;		

			long timeStarted = -1;		
			long timeSinished = -1;		

			try
			{
				timeStarted = System.nanoTime();
	
				s = new Socket(addr_a, port_a);			
		
				s.setTcpNoDelay(true);	
				
				oos = new ObjectOutputStream(s.getOutputStream());
				ois = new ObjectInputStream(s.getInputStream());		

				for (int i = 0; i < 10; i++)
				{
					oos.writeBoolean(true);
					oos.writeObject("travel");					
					oos.flush();

					Double cost = (Double) ois.readObject();				
				}

				oos.writeBoolean(false);
				oos.flush();

				oos.writeObject("ACCEPT");
				oos.writeObject(new Address("address"));
				oos.flush();

				//System.out.println("Received dispatch date: " + (Date) ois.readObject());
				Date d = (Date) ois.readObject();
				
				timeSinished = System.nanoTime();
			}
			finally
			{
				System.out.println((timeSinished - timeStarted) / 1000);
				
				close(oos, ois, s);
			}
		}
	}

	public static void main(String[] args) throws Exception
	{
		new SCustomer(args[0], Integer.parseInt(args[1]), Integer.parseInt(args[2]));
	}
	
	private void close(ObjectOutputStream oos, ObjectInputStream ois, Socket s)
	{
		try
		{
			if (oos != null) 
			{
				oos.flush();						
				oos.close();
			}
			if (ois != null) ois.close();
			if (s != null) s.close();
		}
		catch (IOException ioe) { }	
	}	
}
