//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/ticketagency/socket/SService.sj -d tests/classes/
//$ bin/sj -cp tests/classes/ benchmarks.ticketagency.socket.SService 8888

package benchmarks.ticketagency.socket;

import java.io.*;
import java.net.*;
import java.util.Date;

import benchmarks.ticketagency.Address;

class SService 
{
	public SService(int port) throws Exception
	{		
		ServerSocket ss = null;
		
		try
		{		
			ss = new ServerSocket(port);
		
			while (true) 
			{
				Socket s = null;
				ObjectInputStream ois = null;
				ObjectOutputStream oos = null;

				try
				{
					s = ss.accept();						

					s.setTcpNoDelay(true);	

					ois = new ObjectInputStream(s.getInputStream());
					oos = new ObjectOutputStream(s.getOutputStream());						

					Address a = (Address) ois.readObject();				

					oos.writeObject(new Date());
					oos.flush();
				}
				finally 
				{
					close(oos, ois, s);
				}			
			}
		}
		finally
		{
			if (ss != null) 
			{
				ss.close();
			}
		}
	}

	public static void main(String[] args) throws Exception
	{
		new SService(Integer.parseInt(args[0]));
	}
	
	private void close(ObjectOutputStream oos, ObjectInputStream ois, Socket s)
	{
		try
		{
			if (oos != null) 
			{
				oos.flush();						
				oos.close();
			}
			if (ois != null) ois.close();
			if (s != null) s.close();
		}
		catch (IOException ioe) { }	
	}	
}
