//$ bin/sjc tests/src/compiler/recursion/AClient.sj -d tests/classes/compiler/recursion/
//$ bin/sj -cp tests/classes/compiler/recursion/ AClient localhost 7777

import java.util.*;

import sj.runtime.*;
import sj.runtime.net.*;

public class AClient
{
	private protocol p_meth2
	{
		rec meth2[
			?(int)
			.!{
				REDOX: #meth1,
				REDOY: #meth2,
				QUIT: //!<String>
			}
		]	
	}

	private protocol p_meth1
	{
		rec meth1[
			?(int)
			.@p_meth2
		]
	}

	private protocol p { begin.@p_meth1 }		

	public AClient(String server, int port) throws Exception
	{
		SJServerAddress c = SJServerAddress.create(p, server, port);	
		SJSocket s = SJFSocket.create(c);			
		
		try (s)
		{
			s.request();
			
			//BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
			//try { br.readLine(); } catch(IOException ioe) { }				

			meth(s);									
			//meth1(s);					
		}
		finally
		{
			
		}		
	}

	private void meth(@p_meth1 s) throws SJIOException
	{
		int i = 0;
	
		s.recursion(meth1)
		{		
			System.out.println("Received: " + s.receiveInt());				

			s.recursion(meth2)
			{
				System.out.println("Received: " + s.receiveInt());				

				if(i++ < 5)
				{				
					if (i % 2 == 0)
					{
						s.outbranch(REDOX)
						{
							s.recurse(meth1);
						}
					}
					else
					{
						s.outbranch(REDOY)
						{
							s.recurse(meth2);
						}						
					}
				}
				else
				{
					s.outbranch(QUIT)
					{
						//s.send("Bye!");
					}
				}				
			}
		}
	}
	
	private sessrec void meth1(@p_meth1 s) throws SJIOException
	{
		System.out.println("Received: " + s.receiveInt());
		
		meth2(s);
	}
	
	private sessrec void meth2(@p_meth2 s) throws SJIOException
	{
		int i = 0;
	
		System.out.println("Received: " + s.receiveInt());				

		if (i++ < 5)
		{
			if (i % 2 == 0)
			{
				s.outbranch(REDOX)
				{
					meth1(s);
				}
			}
			else
			{
				s.outbranch(REDOY)
				{
					meth2(s);
				}						
			}
		}
		else
		{
			s.outbranch(QUIT)
			{

			}
		}	
	}
	
	public static void main(String[] args) throws Exception
	{			
		new AClient(args[0], Integer.parseInt(args[1]));
	}	
}
