// bin/sjc tests/src/runtime/rsocket/delegation/case3/C.sj -d tests/classes/
// bin/sj -cp tests/classes/ runtime.rsocket.delegation.case3.C 9999

package runtime.rsocket.delegation.case3;

import sj.runtime.*;
import sj.runtime.net.*;

class C 
{
	public static void main(String[] args) throws Exception 
	{
		protocol p_d { ?(String).!<String> }		
		protocol p_a { ?(String).?(@p_d) }
		protocol p_b { begin.?(@p_a) }

		SJServerSocket ss = null;

		try
		{
			ss =  SJRServerSocket.create(p_b, Integer.parseInt(args[0]));
		
			SJSocket s_b = null;		
			SJSocket s_a = null;
			SJSocket s_d = null;

			try (s_b, s_a, s_d)
			{
				s_b = ss.accept();

				s_a = (@p_a) s_b.receive();

				System.out.println("Received: " + (String) s_a.receive());

				s_d = (@p_d) s_a.receive();

				System.out.println("Received: " + (String) s_d.receive());
				
				s_d.send("Hello from C!");				
			}
			finally
			{

			}
		}
		finally
		{
			if (ss != null) ss.close();
		}
	}
}
