//$ bin/sjc tests/src/ticketagency/Service.sj -d tests/classes/
//$ bin/sj -cp tests/classes/ ticketagency.Service 8888

package ticketagency;

import java.io.IOException;
import java.util.Date;

import sj.runtime.*;
import sj.runtime.net.*;

class Service 
{
	public Service(int port) throws IOException
	{
		//protocol p_sc { ?(Address).!<Date> }

		protocol p_sa { begin.?(?(Address).!<Date>)	}

		SJServerSocket ss_sa = SJRServerSocket.create(p_sa, port); // Need assigns as well as declarations (for exception scope flexibility).
		
		while (true) // While not session type checked yet.
		{
			SJSocket s_sa = null;		
			SJSocket s_sc = null;
			
			try (s_sc, s_sa)
			{
				s_sa = ss_sa.accept();				
				//s_sc = (?(Address).!<Date>) s_sa.receive();
				s_sc = s_sa.receive();

				storeInDatabase((Address) s_sc.receive());
				
				Date date = getDate();
				
				System.out.println("Estimated dispatch date: " + date);
				
				s_sc.send(date);
			}
			catch (SJIOException ioe) 
			{ 
				ioe.printStackTrace(); 
			}
			catch (ClassNotFoundException cnfe) 
			{ 
				cnfe.printStackTrace(); 
			}
			catch (SJIncompatibleSessionException stise) 
			{ 
				stise.printStackTrace(); 
			}
			finally 
			{

			}			
		}
	}

	private void storeInDatabase(Address custAddr) 
	{
		System.out.println("Storing customer address: " + custAddr);
	}

	private Date getDate() 
	{
		return new Date();
	}

	public static void main(String[] args) throws IOException
	{
		new Service(Integer.parseInt(args[0]));
	}
}
